/*
 * NoGray JavaScript Library
 *
 * Copyright (c), All right reserved
 * Gazing Design - http://www.NoGray.com
 * http://www.nogray.com/license.php
 */
 
 /*
		The library needs to include images and CSS styles to format different objects and components.
		Also, language files are need for localization. In order to achieve this, the library includes
		an assets folder which includes all the CSS, images and language files.
*/
var ng_config_defaults = {
	assets_dir: null, // null will default to the ng_all.js folder,
	
	css_skin_prefix: 'ng_',
	
	use_ui: true,						// use UI features from version 1.2.0
	load_icons: false,					// load the icons CSS file (vs 1.2.0)
	
	language: 'en',
	
	button_color: 'transparent',		// deprecated and will be removed in vs 1.2.5
	button_over_color: '#ffd06e',		// deprecated and will be removed in vs 1.2.5
	button_disable_color: null,			// deprecated and will be removed in vs 1.2.5
	button_down_color: null,			// deprecated and will be removed in vs 1.2.5
	button_text_color: null,			// deprecated and will be removed in vs 1.2.5
	button_checked_color: '#f5be5b',	// deprecated and will be removed in vs 1.2.5
	button_gloss: false,				// deprecated and will be removed in vs 1.2.5
	button_light_border: false
};
/*[NGLITEONLY OPEN]*/
/*
		The Lite version doesn't have an ng.XHR object,
		So the language variables are added on the top of the file
*/
var ng_lang = {
	en: {
		general: {
			direction: 'ltr',
			
			numbers: ['0','1','2','3','4','5','6','7','8','9'],
			numbers_ordinal: ['st', 'nd', 'rd', 'th'],
			
			date: {
				date_format: 'm/d/Y',
				time_format: 'h:i A',
				
				days:{
					'char':['S','M','T','W','T','F','S'],
					'short':['Su','Mo','Tu','We','Th','Fr','Sa'],
					'mid':['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],
					'long':['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']
				},
				months:{
					'short':['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],
					'long':['January','February','March','April','May','June','July','August','September','October','November','December']
				},
				am_pm:{
					lowercase:['am','pm'],
					uppercase:['AM','PM']
				}
			},
			
			yes: 'Yes',
			no: 'No',
			
			'open': 'Open',
			'close': 'Close',
			clear: 'Clear',
	
			complete: 'Complete',
			loading: 'Loading'
		}	
	}
};
var ng={version:"1.2.2",is_lite:true,start_ini_time:new Date().getTime(),browser:{ie:!!((window.attachEvent&&!window.opera)||(navigator.userAgent.indexOf("Trident")>-1)),ie6:!!(document.attachEvent&&!window.opera&&!window.XMLHttpRequest),opera:!!(window.opera),webkit:(navigator.userAgent.indexOf("AppleWebKit/")>-1),chrome:(navigator.userAgent.indexOf("Chrome/")>-1),gecko:(navigator.userAgent.indexOf("Gecko")>-1&&navigator.userAgent.indexOf("KHTML")==-1&&navigator.userAgent.indexOf("Trident")==-1),mobile_safari:!!navigator.userAgent.match(/Apple.*Mobile.*Safari/),get_ie_version:function(){if(!ng.browser.ie){return -1}if(ng.defined(ng.browser.cached_ie_version)){return ng.browser.cached_ie_version}var d=navigator.userAgent.indexOf("MSIE");var c=-1;var a=navigator.userAgent;if(d==-1){d=a.indexOf("Trident");d=a.indexOf(":",d)+1;c=parseFloat(a.substr(d))}else{var b=new RegExp("MSIE ([0-9]{1,}[.0-9]{0,})");if(b.exec(a)!=null){c=parseFloat(RegExp.$1)}}ng.browser.cached_ie_version=c;return c},cached_ie_version:null,supported_input:null,support_input:function(b){var b=b.toLowerCase();if(!ng.defined(ng.browser.supported_input)){ng.browser.supported_input={}}if(!ng.defined(ng.browser.supported_input[b])){var a=document.createElement("input");a.setAttribute("type",b);ng.browser.supported_input[b]=(a.type.toLowerCase()==b)}return ng.browser.supported_input[b]},loaded:false},defined:function(a){return(a!=undefined)},type:function(a){if(!ng.defined(a)){return"undefined"}if(a.has_type){return a.has_type}else{if(a.callee){return"arguments"}else{if(a.tagName){return"html_element"}else{return typeof a}}}},random:function(b,a,d){if(!ng.defined(d)){d=[]}if(ng.type(d)!="array"){d=[d]}var c=0;while(1){c=Math.floor(Math.random()*(a-b+1)+b);if(!d.has(c)){return c}}},random_id:function(a){if(!ng.defined(a)){a="random"}return"ng_"+a+"_"+ng.random(0,9999)+"_"+ng.random(0,9999)},extend:function(c,a){for(var b in a){if(ng.type(a[b])=="array"){if(ng.defined(a[b].clone)){c[b]=a[b].clone()}else{c[b]=a[b]}}else{if(ng.type(a[b])=="object"){c[b]=ng.obj_clone(a[b])}else{if(ng.defined(a[b].clone)){c[b]=a[b].clone()}else{c[b]=a[b]}}}}return c},extend_proto:function(b,a){ng.extend(b.prototype,a)},extend_event:function(a){if(ng.defined(a.ng_extended)){return a}a.ng_extended=true;if((ng.defined(a.targetTouches))&&(ng.defined(a.targetTouches[0]))&&(ng.defined(a.targetTouches[0].pageX))){a.pointerId=a.targetTouches[0].identifier;a.top=a.targetTouches[0].pageY;a.left=a.targetTouches[0].pageX}else{if(a.pageX){a.top=a.pageY;a.left=a.pageX}else{a.top=(a.clientY+Math.max(document.documentElement.scrollTop,document.body.scrollTop));a.left=(a.clientX+Math.max(document.documentElement.scrollLeft,document.body.scrollLeft))}}if(a.wheelDelta){a.wheel=(a.wheelDelta/120)}a.stop_bubble=function(){this.is_stopped=true;if(this.stopPropagation){this.stopPropagation()}else{this.cancelBubble=true}return this}.bind(a);a.stop_default=function(){this.is_stopped=true;if(this.preventDefault){this.preventDefault()}else{this.returnValue=false}return this}.bind(a);a.is_stopped=false;a.stop=function(){this.stop_bubble();this.stop_default();return this}.bind(a);if(!a.target){a.src_element=ng.get(a.srcElement)}else{a.src_element=ng.get(a.target)}a.code=(a.keyCode||a.which);if(!ng.defined(a.key)){if((a.type.toLowerCase()=="keydown")||(a.type.toLowerCase()=="keyup")){var c=[];c[27]="esc";c[8]="backspace";for(var b=112;b<=123;b++){c[b]="f"+(a.code-111)}c[19]="pause break";c[45]="ins";c[46]="del";c[144]="num lock";c[9]="tab";c[20]="caps lock";c[16]="shift";c[17]="ctrl";c[91]="windows";c[18]="alt";c[93]="context";c[38]="up";c[39]="right";c[40]="down";c[37]="left";c[36]="home";c[33]="pg up";c[34]="pg dn";c[35]="end";c[32]="space";c[13]="enter";if(ng.defined(c[a.code])){a.key=c[a.code]}else{a.key=String.fromCharCode(a.code).toLowerCase()}}else{a.key=String.fromCharCode(a.code)}}a.get_key=function(){var d=this.key;if(d.length>1){d=d.toLowerCase()}var e={pageup:"pg up",pagedown:"pg dn",insert:"ins",capslock:"caps lock",control:"ctrl",win:"windows",apps:"context",spacebar:"space"};if(ng.defined(e[d])){d=e[d]}return d};return a},array:function(e,c){if(ng.type(e)=="array"){return e}else{if(ng.type(e)=="string"){if(!ng.defined(c)){c=","}return e.split(c)}else{if(ng.type(e)=="arguments"){return Array.prototype.slice.call(e,0)}else{if(ng.defined(e.length)){var a=[];for(var d=0,b=e.length;d<b;d++){a.push(e[d])}return a}}}}return[e]},ready:function(a){if(ng.browser.loaded){a.defer()}else{ng.ready_funcs_arr.push(a)}},on_ready_arr:{},on_ready_timer:0,on_ready:function(b,a){if(ng.defined(b)){if(ng.defined(document.getElementById(b))){a.defer(ng.get(b));if(ng.defined(ng.on_ready_arr[b])){delete ng.on_ready_arr[b]}}else{if(!ng.defined(ng.on_ready_arr[b])){ng.on_ready_arr[b]=a}}}else{ng.obj_each(ng.on_ready_arr,function(d,c){ng.on_ready(c,d)})}if(!ng.browser.loaded){clearTimeout(ng.on_ready_timer);ng.on_ready_timer=ng.on_ready.delay(50)}},hold_html:function(a){if(!ng.defined(ng.dump_div)){try{ng.dump_div=document.createElement("div");document.body.insertBefore(ng.dump_div,document.body.firstChild);ng.dump_div.style.display="none";ng.dump_div.style.position="absolute";(function(){try{ng.dump_div.style.top="-500px;"}catch(d){}}.defer())}catch(b){var c=ng.random_id("ng_dump_div");document.write('<div id="'+c+'" style="display:none; position:absolute; top:-500px;"></div>');ng.dump_div=document.getElementById(c)}}ng.dump_div.innerHTML=a},ready_func:function(){if(ng.browser.loaded){return}ng.browser.loaded=true;ng.load_time=new Date().getTime()-ng.start_ini_time;for(var a=0;a<ng.ready_funcs_arr.length;a++){ng.ready_funcs_arr[a].defer()}ng.on_ready();delete ng.ready_funcs_arr,ng.on_ready_arr,ng.on_ready_timer},ready_funcs_arr:[],obj_each:function(f,d,g,c){if(!ng.defined(f)){return}if(ng.defined(f.each)){return f.each(d,g,c)}var a=true;if(!c){c=[]}if(!ng.defined(ng.current_object_properties)){var b={};ng.current_object_properties=",";for(var e in b){ng.current_object_properties+=e+","}}for(var e in f){if(ng.current_object_properties.indexOf(","+e+",")==-1){a=d.apply(g,[f[e],e].concat(c));if(!ng.defined(a)){a=true}if(!a){break}}}return f},obj_merge:function(a,b){if(ng.defined(a.merge)){return a.merge(b)}ng.obj_each(b,function(d,c){a[c]=d});return a},obj_clone:function(a){if(ng.defined(a.clone)){return a.clone()}return ng.extend({},a)},html5_options:function(obj){var obj=ng.get(obj);var tg=obj.get("tag");var obj_type="object";if(((tg=="input")&&(obj.type.toLowerCase()!="submit")&&(obj.type.toLowerCase()!="button"))||(tg=="textarea")||(tg=="select")){obj_type="input"}var re={};if((ng.defined(obj.lang))&&(obj.lang!="")){re.language=obj.lang}var html5_process_val=function(val){if((val.substr(0,4)=="new ")||((val.substr(0,1)=="[")&&(val.substr(val.length-1)=="]"))||((val.substr(0,1)=="{")&&(val.substr(val.length-1)=="}"))){val=eval("("+val+")")}else{if(val.is_numeric()){val=val.to_float()}}return val};if(ng.defined(obj.dataset)){ng.obj_each(obj.dataset,function(val,k){re[k]=html5_process_val(val)})}else{var loop=obj.attributes.length;for(var i=0;i<loop;i++){var nm=obj.attributes[i].nodeName;if(nm.indexOf("data-")!=-1){nm=nm.replace("data-","");re[nm]=html5_process_val(obj.attributes[i].nodeValue)}}}re[obj_type]=obj;if(obj_type=="input"){var typ=obj.getAttribute("type")}else{var typ=obj.get("tag")}if((ng.defined(typ))&&(typ!="")&&(ng.defined(ng.mapped_html5_prop[typ]))){ng.obj_each(ng.mapped_html5_prop[typ],function(v,k){var prop=obj.getAttribute(k);if(!ng.defined(prop)){prop=obj[k]}if((ng.defined(prop))&&(prop!="")){if(ng.type(v)=="function"){var re_obj=v(prop);if(ng.defined(re_obj)){ng.obj_merge(re,re_obj)}}else{re[v]=html5_process_val(prop)}}})}return re},mapped_html5_prop:{},map_html5_prop:function(a,b){var a=a.toLowerCase();if(!ng.defined(ng.mapped_html5_prop[a])){ng.mapped_html5_prop[a]={}}ng.obj_merge(ng.mapped_html5_prop[a],b)}};if(!ng.defined(ng_config)){var ng_config={}}if(ng.defined(ng_config.assests_dir)){ng_config.assets_dir=ng_config.assests_dir}ng.obj_merge(ng_config_defaults,ng_config);ng_config=ng_config_defaults;ng_config.assests_dir=ng_config.assets_dir;ng_config_defaults=null;if(!ng.defined(ng_config.assets_dir)){(function(){var c=document.getElementsByTagName("script");var a="ng_lite.js";for(var b=0;b<c.length;b++){var d=c[b].getAttribute("src");if((ng.defined(d))&&(d.indexOf(a)!=-1)){ng_config.assets_dir=d.replace(a,"assets/");break}}})()}ng.num_of_extra_delay_arguments=0;setTimeout(function(){ng.num_of_extra_delay_arguments=arguments.length},0);ng.extend_proto(Function,{set:function(f,d,c,b){if(!d){var d=[]}if((ng.type(d)!="array")&&(ng.type(d)!="arguments")){d=[d]}if(!ng.defined(c)){var c=-1}else{c=c.to_int()}var a=this;var e=function(){var h=ng.array(arguments);if(c>-1){for(var g=0;g<ng.num_of_extra_delay_arguments;g++){h.remove_key(0)}}return a.apply(f,h.concat(d))};if(c<=-1){return e}else{if(b){return setInterval(e,c)}else{return setTimeout(e,c)}}},bind:function(b,a){return this.set(b,a)},delay:function(b,c,a){return this.set(c,a,b)},repeat:function(b,c,a){return this.set(c,a,b,true)},defer:function(b,a){return this.set(b,a,0)},inherit:function(a){this.prototype=new a;this.prototype.constructor=this},rename_method:function(b,a){this.prototype[a]=this.prototype[b];delete this.prototype[b]}});ng.extend_proto(RegExp,{has_type:"regexp"});ng.extend_proto(Array,{has_type:"array",clone:function(){if(window.JSON){return JSON.parse(JSON.stringify(this))}return this.slice()},each:function(e,f,c){var a=true;if(!c){c=[]}for(var d=0,b=this.length;d<b;d++){a=e.apply(f,[this[d],d].concat(c));if(!ng.defined(a)){a=true}if(!a){break}}return this},r_each:function(b,c,a){this.reverse().each(b,c,a);return this.reverse()},get_key:function(c,b){if((!ng.defined(b))&&(this.indexOf)){var a=this.indexOf(c);if(a!=-1){return a}return null}else{if(!ng.defined(b)){var b=function(d){return d}}for(var a=0;a<this.length;a++){if(b(this[a])==b(c)){return a}}}return null},has:function(b,a){return(ng.defined(this.get_key(b,a)))},unique:function(){var b=[];for(var a=0;a<this.length;a++){if(!b.has(this[a])){b.push(this[a])}}return b},remove_value:function(c,b){while(true){var a=this.get_key(c,b);if(!ng.defined(a)){break}this.remove_key(a)}return this},remove_key:function(a){if(!ng.defined(a)){return this}this.splice(a,1);return this},empty:function(){this.length=0;return this}});ng.extend_proto(String,{cap_first_letter:function(){return this.substr(0,1).toUpperCase()+this.substr(1).toLowerCase()},css_camel_case:function(){var a=this.split("-");a.each(function(c,b){if(b>0){a[b]=c.cap_first_letter()}else{a[b]=a[b]}});return a.join("")},css_hyphenate:function(){return this.replace(/([A-Z])/g,"-$1").toLowerCase()},is_numeric:function(){if(this==""){return false}return(this.match(/^([-|+]?\s?\d*\.?\d*)$/)!=null)},to_int:function(){return parseInt(this,10)},to_float:function(){return parseFloat(this)},trim:function(){if(window.trim){return trim(this)}return this.replace(/^\s+|\s+$/g,"")}});ng.extend_proto(Number,{to_int:function(){return parseInt(this,10)},to_float:function(){return parseFloat(this)},round:function(a){a=Math.pow(10,a||0);return Math.round(this*a)/a},is_numeric:function(){if(isNaN(this)){return false}return true},percent:function(a){return(this/100*a)}});ng.extend_proto(Date,{has_type:"date",clone:function(){return new Date(this.getTime())},days_in_month:function(){var a=new Date(this.getFullYear(),this.getMonth()+1,0);return a.getDate()},is_leap_year:function(){var a=new Date(this.getFullYear(),1,29);return(a.getMonth()==1)},from_string:function(g){var c=g.toLowerCase().replace(/(\s)*([\+|-])(\s)*/g,"$2");var b=false;if((c.indexOf("+")!=-1)||(c.indexOf("today-")!=-1)||(c.indexOf("month-")!=-1)||(c.indexOf("year-")!=-1)){b=true}if(!b){g=g.replace("1st","1").replace("2nd","2").replace("3rd","3");var f=Date.parse(g.replace(/[-|\\]/g,"/"))}else{var f=g.to_int()}if(isNaN(f)){var i=this.getFullYear(),a=this.getMonth(),e=this.getDate();g=g.toLowerCase().replace(/(\s)*([\+|-])(\s)*/g,"$2");g=g.replace("yesterday","today-1").replace("tomorrow","today+1").replace("last month","month-1").replace("next month","month+1").replace("last year","year-1").replace("next year","year+1");if(g.indexOf("today+")>=0){e=e+g.replace("today+","").to_int()}else{if(g.indexOf("today-")>=0){e=e-g.replace("today-","").to_int()}else{if(g.indexOf("month+")>=0){a=a+g.replace("month+","").to_int();var h=new Date(i,a,1).days_in_month();if(e>h){e=h}}else{if(g.indexOf("month-")>=0){a=this.getMonth()-g.replace("month-","").to_int();var h=new Date(i,a,1).days_in_month();if(e>h){e=h}}else{if(g.indexOf("year+")>=0){i=i+g.replace("year+","").to_int();var h=new Date(i,a,1).days_in_month();if(e>h){e=h}}else{if(g.indexOf("year-")>=0){i=this.getFullYear()-g.replace("year-","").to_int();var h=new Date(i,a,1).days_in_month();if(e>h){e=h}}}}}}}this.setFullYear(i);this.setMonth(a);this.setDate(e)}else{this.setTime(f)}return this},from_object:function(a){var g={};var d;for(d in a){g[d]=a[d]}var k=ng.defined;if(!k(g.date)){g.date=this.getDate()}if(!k(g.month)){g.month=this.getMonth()}if(!k(g.year)){g.year=this.getFullYear()}if(!k(g.hour)){g.hour=this.getHours()}if(!k(g.minute)){g.minute=this.getMinutes()}if(!k(g.second)){g.second=this.getSeconds()}if(!k(g.millisecond)){g.millisecond=this.getMilliseconds()}if(ng.type(g.date)!="string"){this.setTime(new Date(g.year,g.month,g.date,g.hour,g.minute,g.second,g.millisecond).getTime());return this}g.date=g.date.toLowerCase();var f=new Date(g.year,g.month,1);var b;if(g.date.indexOf("sunday")!=-1){b=0}else{if(g.date.indexOf("monday")!=-1){b=1}else{if(g.date.indexOf("tuesday")!=-1){b=2}else{if(g.date.indexOf("wednesday")!=-1){b=3}else{if(g.date.indexOf("thursday")!=-1){b=4}else{if(g.date.indexOf("friday")!=-1){b=5}else{if(g.date.indexOf("saturday")!=-1){b=6}}}}}}}if(f.getDay()>b){var e=(7-f.getDay())+b+1}else{if(f.getDay()<b){var e=b-f.getDay()+1}else{var e=1}}var l=["1st","2nd","3rd","4th","5th"];var i=5;var j=f.days_in_month();while(g.date.indexOf("last")!=-1){if((e+(i*7))<=j){g.date=g.date.replace("last",l[i])}i--;if(i<0){g.date=g.date.replace("last","1st")}}var h;if(g.date.indexOf("1st")!=-1){h=0}else{if(g.date.indexOf("2nd")!=-1){h=1}else{if(g.date.indexOf("3rd")!=-1){h=2}else{if(g.date.indexOf("4th")!=-1){h=3}else{if(g.date.indexOf("5th")!=-1){h=4}}}}}this.setTime(new Date(g.year,g.month,e+(h*7),g.hour,g.minute,g.second,g.millisecond).getTime());return this},print:function(o,n){var a=ng.Language.get_language(n).date;if(!ng.defined(o)){var o=a.date.date_format+" "+a.date.time_format}var k=this.getDate();var r=this.getDay();var c=this.getMonth();var l=this.getFullYear();var j=this.getHours();var q="";if(!ng.defined(a.numbers_ordinal)){if(n=="en"){a.numbers_ordinal=["st","nd","rd","th"]}else{a.numbers_ordinal=["","","",""]}}o=o.replace(/c/g,"Y-m-dTH:i:sP");o=o.replace(/r/g,"D, d M Y H:i:s O");for(var f=0;f<o.length;f++){var b=o.charAt(f);if(b=="d"){if(k<10){q+="0"}q+=k}else{if(b=="D"){q+=a.days["mid"][r]}else{if(b=="j"){q+=k}else{if(b=="l"){q+=a.days["long"][r]}else{if(b=="N"){var g=r;if(g==0){g=7}q+=g}else{if(b=="S"){if((k==1)||(k==21)||(k==31)){q+=a.numbers_ordinal[0]}else{if((k==2)||(k==22)){q+=a.numbers_ordinal[1]}else{if((k==3)||(k==23)){q+=a.numbers_ordinal[2]}else{q+=a.numbers_ordinal[3]}}}}else{if(b=="w"){q+=r}else{if(b=="z"){q+=this.get_day_in_year()}else{if(b=="F"){q+=a.months["long"][c]}else{if(b=="M"){q+=a.months["short"][c]}else{if(b=="m"){if(c+1<10){q+=0}q+=c+1}else{if(b=="n"){q+=c+1}else{if(b=="t"){q+=this.days_in_month()}else{if(b=="L"){if(this.is_leap_year()){q+=1}else{q+=0}}else{if((b=="Y")||(b=="o")){q+=l}else{if(b=="y"){q+=l.toString().substr(2,2)}else{if(b=="a"){if(j<12){q+=a.am_pm.lowercase[0]}else{q+=a.am_pm.lowercase[1]}}else{if(b=="A"){if(j<12){q+=a.am_pm.uppercase[0]}else{q+=a.am_pm.uppercase[1]}}else{if(b=="B"){q+=this.to_swatch_internet_time()}else{if(b=="g"){var p=(j%12);if(p==0){p=12}q+=p}else{if(b=="G"){q+=j}else{if(b=="h"){var p=(j%12);if(p==0){p=12}if(p<10){q+=0}q+=p}else{if(b=="H"){if(j<10){q+=0}q+=j}else{if(b=="i"){if(this.getMinutes()<10){q+=0}q+=this.getMinutes()}else{if(b=="s"){if(this.getSeconds()<10){q+=0}q+=this.getSeconds()}else{if(b=="u"){q+=this.getMilliseconds()}else{if((b=="O")||(b=="P")){var p=-1*(this.getTimezoneOffset())/60;var e=p-Math.floor(p);e=e*60;p=Math.floor(p);e=Math.floor(e);if(p==0){p="00"}else{if((p>-10)&&(p<0)){p="-0"+Math.abs(p)}else{if((p<10)&&(p>0)){p="0"+p}else{p=p.toString()}}}if(p>0){q+="+"}if(e<10){e="0"+e}else{e=e.toString()}if(b=="P"){var s=":"}else{var s=""}q+=p+s+e}else{if(b=="Z"){q+=this.getTimezoneOffset()}else{if(b=="U"){q+=Math.floor(this.time_difference(new Date(1970,0,1))/1000)}else{q+=b}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}return ng.Language.translate_numbers(q,n)},get_week_in_year:function(){return Math.floor(this.get_day_in_year()/7)},get_day_in_year:function(){return Math.floor(this.get_hour_in_year()/24)},get_hour_in_year:function(){return Math.floor(this.get_minute_in_year()/60)},get_minute_in_year:function(){return Math.floor(this.get_second_in_year()/60)},get_second_in_year:function(){return Math.floor(this.get_millisecond_in_year()/1000)},get_millisecond_in_year:function(){return this.time_difference(new Date(this.getFullYear(),0,1))},time_difference:function(a){return this.getTime()-a.getTime()},to_swatch_internet_time:function(){var a=(this.getHours()*3600)+(this.getMinutes()*60)+this.getSeconds()+((this.getTimezoneOffset()+60)*60);var b=Math.floor(a/86.4);return("@"+b)},from_swatch_internet_time:function(b){if(ng.type(b)=="string"){b=b.replace("@","").to_int()}var a=Math.floor(b*86.4)-((this.getTimezoneOffset()+60)*60);this.setTime(new Date(this.getFullYear(),this.getMonth(),this.getDate()).getTime()+(a*1000));return this}});if(document.addEventListener){document.addEventListener("DOMContentLoaded",ng.ready_func,false);window.addEventListener("load",ng.ready_func,false)}else{document.attachEvent("onreadystatechange",function(){var a=document.createElement("script");a.type="text/jscript";a.defer=true;a.text="ng.ready_func();";document.getElementsByTagName("head")[0].appendChild(a)});window.attachEvent("onload",ng.ready_func)}ng.Events=function(){this.p={events:null,has_event:null,func:null}};ng._custom_events={};ng.extend_proto(ng.Events,{has_type:"event",add_event:function(b,c){b=this.fix_event_name(b);if((this.p.is_html)&&(this.is_unsupported_event(b))){var a=this.get_unsupported_event(b,c);b=a[0];c=a[1];a=null}if(!ng.defined(this.p.events)){this.p.events={}}if((ng.defined(this.p.events))&&(!ng.defined(this.p.events[b]))){this.p.events[b]=[]}if(ng.defined(this.p.events)){this.p.events[b].push(c);if(this.p.is_html){if(!ng.defined(this.p.has_event)){this.p.has_event=[]}if(!this.p.has_event.has(b)){if(!ng.defined(this.p.func)){this.p.func={}}this.p.has_event.push(b);if(document.addEventListener){this.p.func[b+"_add"]=function(f){this.fire_event(f.type,null,f)}.bind(this);if(b=="onDommousescroll"){var d="DOMMouseScroll"}else{var d=b.substr(2);if(d.substr(0,2)!="MS"){d=d.toLowerCase()}}this.addEventListener(d,this.p.func[b+"_add"],false)}else{this.p.func[b+"_attach"]=function(){this.fire_event(event.type,null,event)}.bind(this);this.attachEvent(b.toLowerCase(),this.p.func[b+"_attach"])}}}}else{if(document.addEventListener){if(b=="onDommousescroll"){var d="DOMMouseScroll"}else{var d=b.substr(2);if(d.substr(0,2)!="MS"){d=d.toLowerCase()}}this.addEventListener(d,c,false)}else{this.attachEvent(b.toLowerCase(),c)}}return this},add_events:function(a){ng.obj_each(a,function(c,b){this.add_event(b,c)},this);return this},is_unsupported_event:function(a){var b=[];if(!ng.browser.ie){b.push("mouseenter","mouseleave");if(ng.browser.gecko){b.push("mousewheel")}}if(b.length>0){var c=new RegExp("("+b.join("|")+")","gi");return c.test(a)}return false},get_unsupported_event:function(a,c){if(!ng.defined(c)){c=""}if(!ng.defined(this.id)){this.id=ng.random_id("event")}if(this.id==""){this.id=ng.random_id("event")}var b=this.id+"_"+a+"_"+c.toString().replace(/[\s|\n]/g,"");if((a=="onMouseenter")||(a=="onMouseleave")){if((ng.defined(c))&&(!ng.defined(ng._custom_events[b]))){ng._custom_events[b]=function(d){var e=d.relatedTarget;if(!ng.defined(e)){return}var f=ng.get(e);if((this!==f)&&(f.is_child_of(this))){return}c.apply(this,arguments)}.bind(this)}}if(a=="onMousewheel"){if((ng.defined(c))&&(!ng.defined(ng._custom_events[b]))){ng._custom_events[b]=function(d){if(d.detail){d.wheel=-1*d.detail/3}else{d.wheel=0}c.apply(this,arguments)}.bind(this)}return["onDommousescroll",ng._custom_events[b]]}else{if(a=="onMouseenter"){return["onMouseover",ng._custom_events[b]]}else{if(a=="onMouseleave"){return["onMouseout",ng._custom_events[b]]}}}},remove_event:function(b,d){if(!ng.defined(this.p.events)){return}b=this.fix_event_name(b);if((this.p.is_html)&&(this.is_unsupported_event(b))){var a=this.get_unsupported_event(b,d);var c=b+"_"+d.toString().replace(/[\s|\n]/g,"");delete ng._custom_events[c];b=a[0];d=a[1];a=null}if(!ng.defined(this.p.events[b])){return}else{this.p.events[b].remove_value(d)}if(this.p.events[b].length==0){this.clear_events(b)}return this},remove_events:function(a){ng.obj_each(a,function(c,b){this.remove_event(b,c)},this);return this},clear_events:function(b){if(!ng.defined(this.p.events)){return}b=this.fix_event_name(b);if((this.p.is_html)&&(this.is_unsupported_event(b))){ng.obj_each(ng._custom_events,function(e,d){if(d.indexOf(b+"_")===0){delete ng._custom_events[d]}});var a=this.get_unsupported_event(b);b=a[0];a=null}this.p.events[b]=[];if(ng.defined(this.p.has_event)){this.p.has_event.remove_value(b)}if(this.p.is_html){if(document.detachEvent){this.detachEvent(b.toLowerCase(),this.p.func[b+"_attach"])}else{if(b=="onDommousescroll"){var c="DOMMouseScroll"}else{var c=b.substr(2).toLowerCase()}this.removeEventListener(c,this.p.func[b+"_add"],false)}}return this},clear_all_events:function(){if(!ng.defined(this.p.events)){return}ng.obj_each(this.p.events,function(b,a){this.clear_events(a)}.bind(this))},fire_event:function(e,c,b){e=this.fix_event_name(e);var d=false;if((this.p.is_html)&&(this.is_unsupported_event(e))){var a=this.get_unsupported_event(e);e=a[0];a=null;if(window.event){d=true}}if((ng.defined(this.p.events))&&(ng.defined(this.p.events[e]))){if((!ng.defined(b))&&(window.event)){b=event}if(ng.defined(b)){b=ng.extend_event(b)}else{b={}}if(d){b.altRelatedTarget=this}b.continue_stack=true;b.stop=function(){if(this.stop_bubble){this.stop_bubble().stop_default()}if(this.stop_stack){this.stop_stack()}return this}.bind(b);b.stop_stack=function(){this.continue_stack=false;return this}.bind(b);if(!ng.defined(c)){c=[]}if(ng.type(c)!="array"){c=[c]}c.push(b);this.p.events[e].r_each(function(f){if(ng.defined(f)){f.apply(this,c)}return b.continue_stack},this)}return this},fix_event_name:function(a){if(a.substr(0,2)=="on"){a=a.substr(2)}if(a.substr(0,2)!="MS"){a=a.cap_first_letter()}return"on"+a}});ng.Color=function(c,b){this.p={hex:"000000",rgb:null,hsl:null,alpha:1};this.p.rgb=[0,0,0];this.p.hsl=[0,0,0];if(ng.type(c)=="array"){if(!ng.defined(b)){b="rgb"}b=b.toLowerCase();if(b=="hsl"){this.set_hsl(c)}else{this.set_rgb(c)}}else{if(ng.type(c)=="string"){if(c.indexOf("rgb")!=-1){c=c.replace(/[rgb(a)?|\(|\)|\s]/g,"");this.set_rgb(c.split(","))}else{if(c.indexOf("hsl")!=-1){c=c.replace(/[rgb(a)?|\(|\)|\s]/g,"");this.set_hsl(c.split(","))}else{var a=c.toLowerCase();if(a=="aqua"){c="00FFFF"}else{if(a=="black"){c="000000"}else{if(a=="blue"){c="0000FF"}else{if(a=="fuchsia"){c="FF00FF"}else{if(a=="gray"){c="808080"}else{if(a=="green"){c="008000"}else{if(a=="lime"){c="00FF00"}else{if(a=="maroon"){c="800000"}else{if(a=="navy"){c="000080"}else{if(a=="olive"){c="808000"}else{if(a=="purple"){c="800080"}else{if(a=="red"){c="FF0000"}else{if(a=="silver"){c="C0C0C0"}else{if(a=="teal"){c="008080"}else{if(a=="white"){c="FFFFFF"}else{if(a=="yellow"){c="FFFF00"}}}}}}}}}}}}}}}}this.set_hex(c)}}}}};ng.extend_proto(ng.Color,{has_type:"color",set_alpha:function(a){a=a.to_float();if(a>1){a=1}if(a<0){a=0}this.p.alpha=a;return this},get_alpha:function(){return this.p.alpha},hsl_to_rgb:function(){var c=Math.round((this.p.hsl[2]*255)/100);var e=Math.round((this.p.hsl[1]*255)/100);if(e==0){this.p.rgb=[c,c,c]}else{var j=c,f=(255-e)*c/255,d=this.p.hsl[0]%60;d=(j-f)*d/60;var i,h,a;if(this.p.hsl[0]<60){i=j;a=f;h=f+d}else{if(this.p.hsl[0]<120){h=j;a=f;i=j-d}else{if(this.p.hsl[0]<180){h=j;i=f;a=f+d}else{if(this.p.hsl[0]<240){a=j;i=f;h=j-d}else{if(this.p.hsl[0]<300){a=j;h=f;i=f+d}else{if(this.p.hsl[0]<360){i=j;h=f;a=j-d}else{i=h=a=0}}}}}}this.p.rgb=[Math.round(i),Math.round(h),Math.round(a)]}},rgb_to_hsl:function(){var a=this.p.rgb[0]/255,i=this.p.rgb[1]/255,j=this.p.rgb[2]/255,m=0;var d=Math.min(a,i,j),k=Math.max(a,i,j);var c=k-d;var e=Math.round(k*100),n,f;if(c==0){this.p.hsl=[0,0,e]}else{n=Math.round((c/k)*100);del_R=(((k-a)/6)+(c/2))/c;del_G=(((k-i)/6)+(c/2))/c;del_B=(((k-j)/6)+(c/2))/c;if(a==k){f=del_B-del_G}else{if(i==k){f=(1/3)+del_R-del_B}else{if(j==k){f=(2/3)+del_G-del_R}}}if(f<0){f+=1}if(f>1){f-=1}f=Math.round(360*f);this.p.hsl=[f,n,e]}},hex_to_rgb:function(){this.p.rgb=[parseInt(this.p.hex.substr(0,2),16),parseInt(this.p.hex.substr(2,2),16),parseInt(this.p.hex.substr(4,2),16)]},rgb_to_hex:function(){this.p.hex="";for(var a=0;a<this.p.rgb.length;a++){var b=this.p.rgb[a].toString(16);if(b.length<2){b="0"+b}this.p.hex+=b}},set_hsl:function(a){this.p.hsl=[a[0].to_int(),a[1].to_int(),a[2].to_int()];if(a.length>3){this.set_alpha(a[3])}this.hsl_to_rgb();this.rgb_to_hex();return this},get_hsl:function(b){var a=[this.p.hsl[0],this.p.hsl[1],this.p.hsl[2]];if((ng.defined(b))&&(b)){a.push(this.p.alpha)}return a},set_rgb:function(a){this.p.rgb=[a[0].to_int(),a[1].to_int(),a[2].to_int()];if(a.length>3){this.set_alpha(a[3])}this.rgb_to_hsl();this.rgb_to_hex();return this},get_rgb:function(b){var a=[this.p.rgb[0],this.p.rgb[1],this.p.rgb[2]];if((ng.defined(b))&&(b)){a.push(this.p.alpha)}return a},set_hex:function(b){b=b.replace("#","").toUpperCase();if((b.length==3)||(b.length==4)){var a="";b.each(function(c){a=c+c});b=a;a=null}this.p.hex=b.substr(0,6);if(b.length>6){this.set_alpha(Math.round((parseInt(b.substr(6),16)/255)*100)/100)}this.hex_to_rgb();this.rgb_to_hsl();return this},get_hex:function(b){var a="#"+this.p.hex.toUpperCase();if((ng.defined(b))&&(b)){a+=((this.p.alpha*100).to_int()/100*255).toString(16)}return a},invert:function(){return this.set_rgb([255-this.p.rgb[0],255-this.p.rgb[1],255-this.p.rgb[2]])},desaturate:function(){return this.set_hsl([this.p.hsl[0],0,Math.round(this.p.hsl[2]-((this.p.hsl[1]/200)*this.p.hsl[2]))])},mix:function(a,d){if(!ng.defined(d)){d=50}d=d.to_int();var b=100-d;if(ng.type(a)!="color"){a=new ng.Color(a)}var f=this.get_rgb(true);var e=a.get_rgb(true);for(var c=0;c<f.length;c++){f[c]=f[c].percent(b);e[c]=e[c].percent(d)}this.set_rgb([f[0]+e[0],f[1]+e[1],f[2]+e[2],f[3]+e[3]]);return this},get_luminance:function(){return(((0.3*this.get_rgb()[0])+(0.59*this.get_rgb()[1])+(0.11*this.get_rgb()[2]))/255*100)},toString:function(a){return this.get_hex(a)}});ng.Element=function(a){if(ng.type(a)=="string"){a=document.getElementById(a)}if(!ng.defined(a)){return null}if(ng.defined(a.is_ng_element)){return a}a.p={has_event:[],element:null,is_html:true,opacity:null};ng.extend_element(a,ng.Events.prototype);ng.extend_element(a,ng.element_methods);if(!ng.defined(a.id)){a.id=ng.random_id("element")}a.is_ng_element=true;return a};ng.extend_element=function(a,b){if(ng.defined(a.did_extend)){return a}if(ng.defined(a.is_ng_element)){return a}ng.obj_each(b,function(f,c){if(ng.defined(a.__proto__)){a.__proto__[c]=f}else{if(ng.defined(a.prototype)){a.prototype[c]=f}else{try{a[c]=f}catch(d){}}}});return a};ng.element_methods={has_type:"html_element",did_extend:true,remove:function(){this.remove_element()},remove_element:function(){this.clear_all_events();ng.obj_each(this.p,function(b,a){if(ng.defined(b)){if(ng.defined(b.remove_element)){b.remove_element()}else{if((ng.defined(b.remove))&&(ng.type(b.remove)=="function")){b.remove()}}}else{delete this.p[a]}},this);if(ng.defined(this.parentNode)){this.parentNode.removeChild(this)}},set:function(b,a){if(b=="html"){b="innerHTML"}else{if(b=="class"){b="className"}}if(b=="innerHTML"){return this.set_html(a)}this[b]=a;return this},get:function(b){if(b=="html"){b="innerHTML"}else{if(b=="tag"){b="tagName"}else{if(b=="class"){b="className"}}}var a=this[b];if(!ng.defined(a)){if(ng.defined(this.getAttribute)){a=this.getAttribute(b)}else{if(ng.defined(this.getProperty)){a=this.getProperty(b)}}}if(b=="tagName"){return a.toLowerCase()}else{return a}},set_html:function(c,a,b){if(!ng.defined(c)){return this}if(!ng.defined(a)){a="overwrite"}a=a.toLowerCase();if(ng.defined(c.render_html)){c=c.render_html()}if(ng.type(c)=="array"){c=c.join("")}if(a=="bottom"){this.innerHTML+=c}else{if(a=="top"){this.innerHTML=c+this.innerHTML}else{this.innerHTML=c}}if((ng.defined(b))&&(b)){c.eval_script()}return this},get_html:function(){return this.innerHTML},append_element:function(c,a){if(ng.defined(c.render_html)){return this.set_html(c,a)}if(!ng.defined(a)){a="bottom"}a=a.toLowerCase();if(c.is_ng_plugin){var b=c.get_object()}else{var b=ng.get(c)}if(a=="top"){this.insertBefore(b,this.firstChild)}else{if(a=="before"){this.parentNode.insertBefore(b,this)}else{if(a=="after"){this.parentNode.insertBefore(b,this.nextSibling)}else{this.appendChild(b)}}}},replace:function(a){a=ng.get(a);this.parentNode.replaceChild(a,this)},get_plugin:function(){var b=this;while(b.get("tag")!="body"){var a=b.getAttribute("data-ng_plugin");if((ng.defined(a))&&(a!="")&&(ng.defined(ng.all_plugins_arr[a]))){return ng.all_plugins_arr[a]}b=b.get_parent()}return null},get_children:function(b,g){if(!ng.defined(b)){var b="*"}var h=this.getElementsByTagName(b);b=b.toLowerCase();var f=[];var c=h.length;var a=true,e;for(var d=0;d<c;d++){if(h[d].nodeType==1){e=ng.get(h[d]);f.push(e);if(ng.defined(g)){a=(g.bind(this,[e,f.length-1]))();if((ng.defined(a))&&(a===false)){break}}}}return f},get_direct_children:function(j,c){var g=false;var e=this.childNodes;if((ng.defined(j))&&(j!="*")){g=true;j=j.toLowerCase()}var h=[];var f=e.length;var k=true,a;var b;for(var d=0;d<f;d++){if(e[d].nodeType==1){if(!g){b=true}else{if((g)&&(e[d].tagName.toLowerCase()==j)){b=true}else{b=false}}if(b){a=ng.get(e[d]);h.push(a);if(ng.defined(c)){k=(c.bind(this,[a,h.length-1]))();if((ng.defined(k))&&(k===false)){break}}}}}return h},get_children_by_class_name:function(l,n,c){var g=true;var h=true;if((!ng.defined(n))||(n=="*")){h=false;var n="*";var a="."+l}else{var a=n+"."+l}if(ng.defined(this.querySelectorAll)){g=h=false;var e=this.querySelectorAll(a)}else{if(ng.defined(this.getElementsByClassName)){g=false;var e=this.getElementsByClassName(l)}else{n=n.toLowerCase();var e=this.getElementsByTagName(n)}}var k=[];var f=e.length;var m=true,b,j;for(var d=0;d<f;d++){if(e[d].nodeType==1){j=true;b=ng.get(e[d]);if((g)&&(!b.has_class(l))){j=false}if((h)&&(b.get("tag")!=n)){j=false}if(j){k.push(b);if(ng.defined(c)){m=(c.bind(this,[b,k.length-1]))();if((ng.defined(m))&&(m===false)){break}}}}}return k},get_parent:function(){return ng.get(this.parentNode)},is_child_of:function(c){var b=ng.get(c);var a=this;if(b===a){return false}while(a&&a!==b){a=a.parentNode}return(a===b)},clone_element:function(b){if(!ng.defined(b)){b=false}var c=this.cloneNode(b);if((!ng.defined(c.did_extend))||(!c.did_extend)){c.is_ng_element=null}c.className=this.className;var a=1;while(ng.defined(ng.get(this.id+"_"+a))){a++}c.id=this.id+"_"+a;return ng.get(c)},disable:function(){if(this.disabled){return this}this.disabled=true;this.fire_event("disable");return this},enable:function(){if(!this.disabled){return this}this.disabled=false;this.fire_event("enable");return this},get_style:function(b){if(ng.type(b)=="array"){return this.get_styles(b)}b=b.css_camel_case();if((b=="opacity")&&(ng.defined(this.p.opacity))){return this.get_opacity()+"%"}else{if(b=="float"){if(ng.browser.ie){b="styleFloat"}else{if(!ng.browser.webkit){b="cssFloat"}}}}var k=this.style[b];if(k==""){if(this.currentStyle){k=this.currentStyle[b];if((k=="")&&(b=="styleFloat")){k=this.currentStyle["float"]}}else{k=document.defaultView.getComputedStyle(this,null).getPropertyValue(b.css_hyphenate());if((k=="")&&(b=="cssFloat")){k=document.defaultView.getComputedStyle(this,null).getPropertyValue("float")}}}if(!ng.defined(k)){k=""}if(ng.type(k)!="string"){k=k.toString()}if((ng.browser.gecko)&&((b=="left")||(b=="top"))&&(k=="0px")){var f=this.get_style("position");if((f!="absolute")&&(f!="fixed")){k=""}}if((k=="")||(k.toLowerCase()=="auto")){if(b=="top"){k=this.get_position().top+"px"}else{if(b=="left"){k=this.get_position().left+"px"}else{if(b=="right"){k=(this.get_position().left+this.get_width())+"px"}else{if(b=="bottom"){k=(this.get_position().top+this.get_height())+"px"}else{if(b=="width"){k=this.get_width();var g=["paddingRight","paddingLeft","borderRightWidth","borderLeftWidth"];for(var e=0;e<g.length;e++){var l=this.get_style(g[e]).to_int();if(!isNaN(l)){k-=l}}k+="px"}else{if(b=="height"){k=this.get_height();var g=["paddingTop","paddingBottom","borderTopWidth","borderBottomWidth"];for(var e=0;e<g.length;e++){var l=this.get_style(g[e]).to_int();if(!isNaN(l)){k-=l}}k+="px"}}}}}}}if(k==""){var h={padding:["paddingTop","paddingRight","paddingBottom","paddingLeft"],margin:["marginTop","marginRight","marginBottom","marginLeft"],background:["backgroundImage","backgroundColor","backgroundRepeat","backgroundPosition","backgroundAttachment"],font:["fontVariant","fontStyle","fontSize","fontFamily"],border:["borderStyle","borderWidth","borderColor"],borderWidth:["borderTopWidth"]};if((ng.browser.webkit)||(ng.browser.gecko)){h.border=["borderTopStyle","borderTopWidth","borderTopColor"]}if(ng.defined(h[b])){for(var e=0;e<h[b].length;e++){var l=this.get_style(h[b][e]);if(l!=""){k+=l+" "}}}if(k!=""){k=k.trim()}}if(ng.type(k)=="string"){var j=k.indexOf("rgb(");if(j!=-1){var a=k.substr(0,j+4);var d=k.replace(a,"");d=d.substr(d.indexOf(")"));var c=new ng.Color(k.replace(a,"").replace(d,"").split(","));k=a.replace("rgb(","")+c.get_hex().toLowerCase()+d.replace(")","")}}if(b=="zoom"){if(k.toString().indexOf("%")==-1){k=Math.round(k.to_float()*100)}else{k=Math.round(k.to_float())}this.p.zoom=k;k+="%"}if(b=="opacity"){k=Math.round(k.to_float()*100);this.p.opacity=k;k+="%"}return k},get_styles:function(a){if(ng.type(a)!="array"){return this.get_style(a)}var c={};for(var b=0;b<a.length;b++){c[a[b]]=this.get_style(a[b])}return c},set_style:function(c,b){if(ng.type(c)!="string"){return this.set_styles(c)}var a=c.toLowerCase();if(a=="opacity"){return this.set_opacity(b)}else{if(a=="scroll"){return this.set_scroll(b)}else{if(a.replace("-","")=="scrolltop"){return this.set_scroll_top(b)}else{if(a.replace("-","")=="scrollleft"){return this.set_scroll_left(b)}}}}if(ng.type(b)=="color"){if((ng.browser.ie)&&(ng.browser.get_ie_version()<9)){b=b.get_hex()}else{b="rgba("+b.get_rgb(true).join(",")+")"}}else{if(b.is_numeric()){if((a=="width")||(a=="height")){if(b<0){b=0}}if(a.replace("-","")!="zindex"){b=Math.round(b)+"px"}}}if(c.charAt(0)=="-"){if(this.style.setProperty){this.style.setProperty(c.css_hyphenate(),b,null)}else{this.style.setAttribute(c.css_camel_case(),b)}}else{if(a=="float"){if(ng.browser.ie){c="styleFloat"}else{c="cssFloat"}}this.style[c.css_camel_case()]=b}return this},set_styles:function(a){ng.obj_each(a,function(c,b){this.set_style(b,c)},this);return this},set_ie_filter:function(c,e){var f=this.style.filter;if(f==""){this.style.filter=c+"("+e+")"}else{var a=f.split(")");var d=false;for(var b=0;b<a.length;b++){if(a[b].indexOf(c)!=-1){if(e==""){delete a[b]}else{a[b]=c+"("+e}d=true}}if(!d){this.style.filter+=" "+c+"("+e+")"}else{this.style.filter=a.join(")")}}return this},set_opacity:function(a){a=a.to_int();if(a<0){a=0}if(a>100){a=100}if(a==this.get_opacity()){return}if((ng.browser.ie)&&ng.defined(this.currentStyle)&&(ng.browser.get_ie_version()<8)){if(!this.currentStyle.hasLayout){this.set_width(this.get_style("width"))}if(a>=100){this.set_ie_filter("progid:DXImageTransform.Microsoft.BasicImage","")}else{this.set_ie_filter("progid:DXImageTransform.Microsoft.BasicImage","opacity="+(a/100))}}this.style.opacity=a/100;this.p.opacity=a;return this},get_opacity:function(){if(!ng.defined(this.p.opacity)){var a=this.get_style("opacity").to_int();if((isNaN(a))||(!ng.defined(a))){this.p.opacity=100;return 100}return a}return this.p.opacity},set_scroll:function(c,b){if((!ng.defined(b))&&(ng.type(c)=="string")){var a=c.split(" ");c=a[0].to_int();b=a[1].to_int()}return this.set_scroll_top(c).set_scroll_left(b)},get_scroll:function(){return this.get_scroll_top()+" "+this.get_scroll_left()},set_scroll_top:function(a){this.scrollTop=a.to_int();return this},get_scroll_top:function(){return this.scrollTop},set_scroll_left:function(a){this.scrollLeft=a.to_int();return this},get_scroll_left:function(){return this.scrollLeft},get_width:function(){return this.offsetWidth},set_width:function(a){return this.set_style("width",a)},get_height:function(){return this.offsetHeight},set_height:function(a){return this.set_style("height",a)},get_position:function(){var a=Math.max(document.body.scrollTop,document.documentElement.scrollTop)-document.documentElement.clientTop;var i=Math.max(document.body.scrollLeft,document.documentElement.scrollLeft)-document.documentElement.clientLeft;var g=false;if(document.body.dir.toLowerCase()=="rtl"){g=true}if((!g)&&(ng.doc.dir.toLowerCase()=="rtl")){g=true}if((!g)&&(ng.get(document.body).get_style("direction")=="rtl")){g=true}if((!g)&&(ng.get(ng.doc).get_style("direction")=="rtl")){g=true}if(g){var d=-1}else{var d=1}if(this.getBoundingClientRect){var e=this.getBoundingClientRect();return{top:e.top+a,left:e.left+(d*i),bottom:e.bottom+a,right:e.right+(d*i)}}if(this.get_style("position")=="fixed"){return{top:this.offsetTop+a,left:this.offsetLeft+(d*i),bottom:this.offsetTop+a+this.get_height(),right:this.offsetLeft+(d*i)+this.get_width()}}var b=this;var f=b.offsetTop;var h=b.offsetLeft;var c=0,j=0;while(b=b.offsetParent){if(!ng.browser.opera){j=ng.get(b).get_style("borderTopWidth").to_int();if(isNaN(j)){j=ng.get(b).get_style("borderWidth").to_int();if(isNaN(j)){j=0}}c=ng.get(b).get_style("borderLeftWidth").to_int();if(isNaN(c)){c=ng.get(b).get_style("borderWidth").to_int();if(isNaN(c)){c=0}}}f+=b.offsetTop+j;h+=b.offsetLeft+c}return{top:f,left:h,bototm:f+this.get_height(),right:h+this.get_width()}},add_class:function(a){if(!this.has_class(a)){var a=this.className+" "+a;a.trim();this.className=a}return this},remove_class:function(a){var b=this.className;this.className=b.split(" ").remove_value(a).join(" ");return this},has_class:function(a){return(this.className.split(" ").has(a))},toggle_class:function(b,a){if(this.has_class(b)){this.remove_class(b).add_class(a)}else{this.remove_class(a).add_class(b)}return this}};if(ng.defined(window.HTMLElement)){ng.extend_proto(HTMLElement,ng.Events.prototype);ng.extend_proto(HTMLElement,ng.element_methods)}ng.get=function(a){if(!ng.defined(a)){return a}if((a.is_ng_element)||(a.is_ng_plugin)){return a}return ng.Element(a)};ng.create=function(a,c){if(!ng.defined(c)){c={}}var b=ng.get(document.createElement(a));ng.obj_each(c,function(e,d){if((d=="styles")||(d=="style")){b.set_styles(e)}else{if((d=="events")||(d=="event")){b.add_events(e)}else{b.set(d,e)}}});return b};ng.doc=ng.get(document.documentElement);ng.InnerHtmlEvents=function(a){this.p={};this.id=ng.random_id("innerhtmlevent");this.add_events(a);ng.global_innerhtml_events[this.id]=this};ng.extend_proto(ng.InnerHtmlEvents,ng.Events.prototype);ng.extend_proto(ng.InnerHtmlEvents,{has_type:"innerhtml_event",get_html:function(){var a=[];var b=[];ng.obj_each(this.p.events,function(d,c){if(!b.has(c)){a.push(c+"=\"ng.global_innerhtml_events['"+this.id+"'].fire_event('"+c+"', ng.get(this), event);\"");b.push(c)}},this);return a.join(" ")},remove:function(){this.p=null;delete ng.global_innerhtml_events[this.id]},toString:function(){return this.get_html()}});ng.global_innerhtml_events={};ng.Assets={has_type:"assets",p:{scripts:[],styles:[]},load:function(c,b){if(ng.type(c)=="array"){for(var a=0;a<c.length;a++){ng.Assets.load(c[a])}}else{if(c.indexOf(".js")!=-1){ng.Assets.load_script(c,b)}else{if(c.indexOf(".css")!=-1){ng.Assets.load_style(c)}}}},load_script:function(f,d){if(!this.p.scripts.has(f)){var a=document.createElement("script");a.type="text/javascript";a.src=f;var b=d;if(ng.defined(d)){if(ng.browser.ie){a.onreadystatechange=function(){if((a.readyState=="complete")||(a.readyState=="loaded")){b.call();b=function(){}}}}else{a.onload=d}}document.getElementsByTagName("head")[0].appendChild(a);this.p.scripts.push(f)}else{try{d.call()}catch(c){}}return this},load_style:function(b){if(!this.p.styles.has(b)){var a=document.createElement("link");a.type="text/css";a.rel="stylesheet";a.href=b;document.getElementsByTagName("head")[0].appendChild(a);this.p.styles.push(b)}return this}};if(!ng_config.use_ui){ng.Assets.load_style(ng_config.assets_dir+"css/"+ng_config.css_skin_prefix+"all.css")}else{ng.ready(function(){if(!ng.defined(ng.UI)){ng.Assets.load_style(ng_config.assets_dir+"css/"+ng_config.css_skin_prefix+"all.css")}})}ng.ready(function(){var b=document.getElementsByTagName("script");for(var d=0,a=b.length;d<a;d++){ng.Assets.p.scripts.push(b[d].src)}var c=document.getElementsByTagName("link");for(var d=0,a=c.length;d<a;d++){if(c[d].rel.toLowerCase()=="stylesheet"){ng.Assets.p.styles.push(c[d].src)}}});ng.Language={p:{default_language:ng_config.language,languages:{}},load:function(a,b){if(!ng.defined(a)){a="general"}if(!ng.defined(b)){b=ng.Language.p.default_language}ng.Language.set_language(b,ng_lang[b][a]);ng.Language.p.default_language=b;ng.Language.p.default_language=b;return ng.Language},set_language:function(b,a){if(!ng.defined(b)){b=ng.Language.p.default_language}if(!ng.defined(ng.Language.p.languages[b])){ng.Language.p.languages[b]={}}ng.obj_merge(ng.Language.p.languages[b],a);return ng.Language},get_language:function(a){if(!ng.defined(a)){a=ng.Language.p.default_language}return ng.Language.p.languages[a]},translate_numbers:function(c,b){if(!ng.defined(b)){b=ng.Language.p.default_language}if(b=="en"){return c}if(ng.defined(ng.Language[b+"_translate_numbers"])){return ng.Language[b+"_translate_numbers"](c,b)}c=c+"";for(var a=0;a<10;a++){c=c.replace(new RegExp(a,"g"),ng.Language.get_language(b).numbers[a])}return c},numbers_to_english:function(d,c){if(!ng.defined(c)){c=ng.Language.p.default_language}if(c=="en"){return d}if(ng.defined(ng.Language[c+"_numbers_to_english"])){return ng.Language[c+"_numbers_to_english"](d,c)}var b=ng.Language.get_language(c);for(var a=0;a<b.numbers.length;a++){d=d.replace(new RegExp(b.numbers[a],"g"),a)}return d},date_to_english:function(c,g){if(!ng.defined(g)){g=ng.Language.p.default_language}if(g=="en"){return c}if((ng.is_lite)&&(!ng.defined(ng_lang.en))){return c}ng.Language.load("general","en");if(ng.defined(ng.Language[g+"_date_to_english"])){return ng.Language[g+"_date_to_english"](str,g)}var e=ng.Language.get_language(g).date;var f=ng.Language.get_language("en").date;var b=function(i,h){if(i!=""){c=c.replace(i,a[h])}};var a=f.months["long"];for(var d=e.months["long"].length-1;d>=0;d--){b(e.months["long"][d],d)}var a=f.months["short"];for(var d=e.months["short"].length-1;d>=0;d--){b(e.months["short"][d],d)}var a=f.days["long"];for(var d=e.days["long"].length-1;d>=0;d--){b(e.days["long"][d],d)}var a=f.days.mid;for(var d=e.days.mid.length-1;d>=0;d--){b(e.days.mid[d],d)}var a=f.am_pm.lowercase;for(var d=e.am_pm.lowercase.length-1;d>=0;d--){b(e.am_pm.lowercase[d],d)}var a=f.am_pm.uppercase;for(var d=e.am_pm.uppercase.length-1;d>=0;d--){b(e.am_pm.uppercase[d],d)}return ng.Language.numbers_to_english(c,g)},t:function(b,a){if(!ng.defined(a)){a=ng.Language.p.default_language}return ng.Language.get_language(a)[b]},get_dir:function(a){return ng.Language.t("direction",a)}};ng.Language.load();ng.PlugIn=function(a){this.p=this.create_options(a,{object:null,language:null});this.create_events()};ng.extend_proto(ng.PlugIn,ng.Events.prototype);ng.extend_proto(ng.PlugIn,{has_type:"plugin",is_ng_plugin:true,create_options:function(b,c){var a={};if(ng.defined(this.p)){ng.obj_merge(a,this.p)}if((ng.type(b)=="string")||(ng.type(b)=="html_element")){b=ng.html5_options(b)}if(ng.defined(c)){ng.obj_merge(a,c)}if(ng.defined(b)){ng.obj_merge(a,b)}return a},create_events:function(){if(ng.defined(this.p.events)){var a=this.p.events;delete this.p.events;this.add_events(a)}},get_position:function(){return this.get_object().get_position()},get_width:function(){return this.get_object().get_width()},get_height:function(){return this.get_object().get_height()},set_object:function(a){if(ng.defined(this.p.object)){ng.get(this.p.object).setAttribute("data-ng_plugin","");ng.get(this.p.object).setAttribute("data-ng_skip","")}if(ng.defined(a)){this.p.object=ng.get(a);this.p.object.setAttribute("data-ng_plugin",this.id);this.p.object.setAttribute("data-ng_skip","1")}return this},get_object:function(){return this.p.object},make_id:function(a){if(!ng.defined(a)){var a="plugin"}if(!ng.defined(this.p.id)){this.id=ng.random_id(a)}else{this.id=this.p.id;delete this.p.id}ng.all_plugins_arr[this.id]=this;return this},get_id:function(){if(!ng.defined(this.id)){this.make_id()}return this.id},set_language:function(a){if(!ng.defined(a)){a=ng_config.language}this.p.language=a;if(ng.defined(this.p.object)){this.p.object.dir=ng.Language.get_dir(this.get_language())}return this},get_language:function(){if(!ng.defined(this.p.language)){this.set_language(null)}return this.p.language},q_garbage:function(){(function(){if(!ng.defined(this.p)){return}var a;if((ng.defined(this.get_input))&&(ng.defined(this.get_input()))){a=this.get_input()}else{if(ng.defined(this.get_object())){a=this.get_object()}}if((ng.defined(a))&&(!document.body.contains(a))){this.remove()}}.delay(100,this));return this},remove:function(){if(!ng.defined(this.p)){return this}this.fire_event("beforeremove");var b,a;if(this.is_ng_component){a=this.get_parents_components()}ng.obj_each(this.p,function(d,c){if(ng.defined(d)){if(ng.defined(d.remove_element)){d.remove_element()}else{if((ng.defined(d.remove))&&(ng.type(d.remove)=="function")){var e=true;if(ng.type(this)=="button"){if(this.get_component()){b=this.get_component().id}if(d.id==b){e=false}}else{if((this.is_ng_component)&&(a.has(d.id))){e=false}}if(e){d.remove()}}}}delete this.p[c]},this);this.p=null;ng.all_component_arr[this.id]=ng.all_plugins_arr[this.id]=null;delete ng.all_component_arr[this.id];delete ng.all_plugins_arr[this.id]},set:function(b,a){if(ng.defined(this["set_"+b])){return this["set_"+b](a)}this.p[b]=a;return this},get:function(a){if(!ng.defined(this.p[a])){return null}if(ng.defined(this["get_"+a])){return this["get_"+a]()}return this.p[a]}});ng.Component=function(a){this.p=this.create_options(a,{content:null,input:null,placement:"aaaa",visible:false,offset:null,open:false,button:null,parent:null,disabled:false,buttons_color:ng_config.button_color,buttons_over_color:ng_config.button_over_color,buttons_down_color:null,buttons_disable_color:null,buttons_gloss:ng_config.button_gloss,buttons_checked_color:ng_config.button_checked_color,button_light_border:ng_config.button_light_border,button_ui_class:"",responsive_top:null,responsive_left:null,is_moving_input:false,open_onfocus:true,open_onclick:true});this.create_events();if(this.p.disabled){this.p.disabled=false;this.disable.delay(100,this)}this.make_id("component");if(ng.defined(this.p.object)){this.set()}};ng.Component.inherit(ng.PlugIn);ng.extend_proto(ng.Component,{has_type:"component",is_ng_component:true,set:function(){if(!ng.defined(this.p.object)){this.set_object(ng.create("div"));document.body.appendChild(this.p.object)}this.set_object(this.p.object);if(ng.defined(this.p.input)){this.set_input(this.p.input)}this.set_language(this.p.language);if(!ng.defined(this.p.placement)){this.p.placement="aaaa"}this.set_placement(this.get_placement().toLowerCase());if(ng.defined(this.p.button)){var a=this.p.button;this.p.button=null;this.set_button(a)}var c=this.get_object();if(!this.p.visible){c.add_class("ng-comp-hidden")}else{this.p.open=true;c.add_class("ng-comp-visible")}var b="right";if(ng.Language.get_dir(this.p.language)=="rtl"){b="left"}if((ng.browser.ie)&&(ng.browser.get_ie_version()<9)){c.set_html('<table cellspacing="0" cellpadding="0" class="ng-comp-table '+ng.Language.get_dir(this.p.language)+'"><tr><td class="ng-comp-main-td" id="'+this.id+'_content"></td><td class="ng-comp-'+b+'-shadow">&nbsp;</td></tr><tr><td class="ng-comp-bottom-shadow">&nbsp;</td><td class="ng-comp-bottom-'+b+'-shadow">&nbsp;</td></tr></table>')}else{c.set_html('<div class="ng-comp-input-holder '+ng.Language.get_dir(this.p.language)+'" id="'+this.id+'_input_div"><div class="ng-comp-close-button" onclick="ng.close_all_component();">&times;</div></div><div class="ng-comp-main-div '+ng.Language.get_dir(this.p.language)+'" id="'+this.id+'_content"></div>')}this.p.content=ng.get(this.id+"_content");ng.all_component_arr[this.id]=this;if(ng.defined(this.p.parent)){if(ng.type(this.p.parent)!="string"){this.p.parent=this.p.parent.id}}if(this.p.disabled){this.disable()}return this},set_parent:function(a){if(a.is_ng_component){this.p.parent=a.id}else{this.p.parent=a}return this},get_parent:function(){return this.p.parent},get_parents_components:function(){var a=[];var b=this;while((ng.defined(b))&&(ng.defined(b.get_parent()))){a.push(b.get_parent());b=ng.all_component_arr[b.parent]}return a},get_children_components:function(){var a=[];ng.obj_each(ng.all_component_arr,function(c,b){if(c.get_parent()==this.id){a.push(b)}},this);return a},set_html:function(c,a,b){if(!ng.defined(this.p.content)){this.set()}this.p.content.set_html(c,a,b);return this},get_html:function(){if(!ng.defined(this.p.content)){this.set()}return this.p.content.get_html()},get_content_div:function(b,a){if(!ng.defined(this.p.content)){this.set()}return this.p.content},get_position_style:function(p){if(!ng.defined(p)){var p=this.get_input()}else{var p=ng.get(p)}if(!ng.defined(p)){return{top:"auto",left:"auto"}}var o=true;if((ng.browser.ie)&&(ng.browser.get_ie_version()<=8)){o=false}if((window.innerWidth<=480)&&(o)){var x=ng.doc.clientHeight;var m=ng.doc.clientWidth;var A=(m-this.get_content_div().get_width())/2;var v=(x-this.get_content_div().get_height())/2;if(ng.defined(this.p.responsive_top)){v=this.p.responsive_top}if(ng.defined(this.p.responsive_left)){A=this.p.responsive_left}if(v<15){v=15}var j={top:Math.max(ng.doc.scrollTop,window.scrollY||0),left:0,right:0,paddingTop:v,height:x};if(ng.Language.get_dir(this.get_language())=="rtl"){j.paddingRight=A}else{j.paddingLeft=A}return j}var i=p.get_position();var g=1;if(ng.Language.get_dir(this.get_language())=="rtl"){g=-1}var t=this.get_offset();var e=t.y;var f=t.x;var q=i.top+e;var u=i.left+(f*g);var n=this.get_object().offsetParent;if((ng.defined(n))&&(n.tagName.toLowerCase()!="body")){var c=ng.get(n).get_position();f-=c.left;e-=c.top}var r=i.top+e;var d=i.left+(f*g);var s=this.p.placement;var k=this.p.content;var l=Math.max(k.get_height(),k.scrollHeight);var b=Math.max(k.get_width(),k.scrollWidth);if(window.innerWidth){var a=window.innerHeight;var z=window.innerWidth}else{var a=ng.doc.get_height();var z=ng.doc.get_width()}var y=Math.max(ng.doc.get_scroll_top(),document.body.scrollTop);var B=Math.max(ng.doc.get_scroll_left(),document.body.scrollLeft);if(s.charAt(0)=="a"){if(((q+l-y)>a)&&(l<=q-y)){s="t"+s.substr(1,1)+"b"+s.substr(3,1)}else{s="b"+s.substr(1,1)+"t"+s.substr(3,1)}}if(s.charAt(1)=="a"){if(g==-1){if(((u+b-(z-B))>z)&&(b<=u-(z-B))){s=s.substr(0,1)+"l"+s.substr(2,1)+"l"}else{s=s.substr(0,1)+"r"+s.substr(2,1)+"r"}}else{if(((u+b-B)>z)&&(b<=u-B)){s=s.substr(0,1)+"r"+s.substr(2,1)+"r"}else{s=s.substr(0,1)+"l"+s.substr(2,1)+"l"}}}if(s.charAt(0)=="b"){r+=p.get_height()}if(s.charAt(1)=="r"){d+=p.get_width()}var j={};if(s.charAt(2)=="t"){j.top=r}else{j.top=r-l}if(s.charAt(3)=="l"){j.left=d}else{j.left=d-b}j.paddingLeft="";j.paddingTop="";j.right="";j.height="";return j},check_parent_id:function(){if(!ng.defined(this.p.input)){return this}if(!ng.defined(ng.get("input_button_container"+this.id))){var a=ng.create("span",{id:"input_button_container"+this.id});this.p.input.append_element(a,"before");a.append_element(this.p.input)}},open:function(a){if(this.is_disabled()){return this}if((this.p.visible)||(this.is_open())){return this}this.p.object.set_styles({display:"inline-block"});ng.get(document.getElementsByTagName("body")[0]).add_class("ng-comp-open");this.check_parent_id();var c=true;if((ng.browser.ie)&&(ng.browser.get_ie_version()<=8)){c=false}if((window.innerWidth<=480)&&(c)){if((ng.defined(this.p.input))&&(this.p.input.parentNode.id!=this.id+"_input_div")){ng.get(this.id+"_input_div").set_style("width",this.get_content_div().get_width());this.p.is_moving_input=true;ng.get(this.id+"_input_div").append_element(this.p.input);(function(){this.p.is_moving_input=false}.defer(this))}}var b=this.get_position_style(a);this.p.object.set_styles(b);this.p.object.set_styles({opacity:100,height:this.p.object.scrollHeight});this.p.open=true;this.show_shim(b);ng.close_all_component(this.id);return this.fire_event("open")},reposition:function(a){if((this.is_open())&&(!this.get_visible())){this.check_parent_id();var c=true;if((ng.browser.ie)&&(ng.browser.get_ie_version()<=8)){c=false}if(c){if(window.innerWidth>=480){if((ng.defined(this.p.input))&&(this.p.input.parentNode.id!="input_button_container"+this.id)){this.p.is_moving_input=true;ng.get("input_button_container"+this.id).append_element(this.p.input,"top");(function(){this.p.is_moving_input=false}.defer(this))}ng.get(document.getElementsByTagName("body")[0].remove_class("ng-comp-open"))}else{if((ng.defined(this.p.input))&&(this.p.input.parentNode.id!=this.id+"_input_div")){ng.get(this.id+"_input_div").set_style("width",this.get_content_div().get_width());this.p.is_moving_input=true;ng.get(this.id+"_input_div").append_element(this.p.input);(function(){this.p.is_moving_input=false}.defer(this))}ng.get(document.getElementsByTagName("body")[0].add_class("ng-comp-open"))}}var b=this.get_position_style(a);this.p.object.set_styles(b);this.show_shim(b)}return this},show_shim:function(b){if(ng.defined(this.p.shim_timer)){clearTimeout(this.p.shim_timer)}if(this.is_disabled()){return this}if((this.p.visible)||(!this.is_open())){return this}if(this.is_shim_required()){if(!ng.defined(this.p.iframe_shim)){var a=ng.random_id("shim_frame");ng.hold_html("<iframe id='ng_iframe_shim"+a+"' src='javascript:\"\";' frameborder='0' class='ng-comp-iframe-shim'></iframe>");this.p.iframe_shim=ng.get("ng_iframe_shim"+a);ng.doc.append_element(this.p.iframe_shim)}this.p.iframe_shim.set_styles({width:this.p.object.get_width()-4,height:this.p.object.get_height()-4,top:b.top,left:b.left,display:"block"});this.p.shim_timer=this.show_shim.delay(250,this,[b])}},close:function(){if(this.is_disabled()){return this}if((this.p.visible)||(!this.is_open())){return this}this.check_parent_id();var a={paddingLeft:"",paddingTop:"",right:"",height:"",display:"none"};var b=true;if((ng.browser.ie)&&(ng.browser.get_ie_version()<=8)){b=false}if(b){if((ng.defined(this.p.input))&&(this.p.input.parentNode.id!="input_button_container"+this.id)){this.p.is_moving_input=true;ng.get("input_button_container"+this.id).append_element(this.p.input,"top");(function(){this.p.is_moving_input=false}.defer(this))}}this.p.object.set_styles(a);ng.get(document.getElementsByTagName("body")[0].remove_class("ng-comp-open"));this.hide_shim();this.p.open=false;return this.fire_event("close")},hide_shim:function(){if(this.is_shim_required()){if(ng.defined(this.p.iframe_shim)){this.p.iframe_shim.set_styles({width:0,height:0,top:-500,left:-500,display:"none"})}}},toggle:function(a){if(this.is_disabled()){return this}if(this.is_open()){return this.close()}else{return this.open(a)}},is_shim_required:function(){return((ng.browser.ie6)||(document.getElementsByTagName("embed").length>0))},is_disabled:function(){if(!ng.defined(this.p.disabled)){this.p.disabled=false}return this.p.disabled},is_enabled:function(){return(!this.is_disabled())},disable:function(){if(this.is_disabled()){return this}this.close();this.get_object().add_class("ng-comp-disabled");ng.obj_each(this.p,function(b,a){if((ng.defined(b))&&(ng.defined(b.disable))&&(ng.type(b.disable)=="function")){b.disable()}});this.p.disabled=true;this.fire_event("disable");return this},enable:function(){if(this.is_enabled()){return this}this.get_object().remove_class("ng-comp-disabled");ng.obj_each(this.p,function(b,a){if((ng.defined(b))&&(ng.defined(b.enable))&&(ng.type(b.enable)=="function")){b.enable()}});this.p.disabled=false;this.fire_event("enable");return this},is_open:function(){if(!ng.defined(this.p.open)){this.p.open=false}return this.p.open},is_close:function(){if(!ng.defined(this.p.open)){this.p.open=false}return !(this.is_open())},set_object:function(a){if(!ng.defined(this.p.object_mouseup_event)){this.p.object_mouseup_event=function(b){ng.close_all_component(this.id);b.stop()}.bind(this)}if((ng.defined(this.p.object))&&(this.p.object.remove_event)){this.p.object.remove_event("mouseup",this.p.object_mouseup_event);this.p.object.setAttribute("data-ng_plugin","");ng.get(this.p.object).setAttribute("data-ng_skip","")}if(ng.defined(a)){this.p.object=ng.get(a);this.p.object.add_event("mouseup",this.p.object_mouseup_event);this.p.object.setAttribute("data-ng_plugin",this.id);this.p.object.setAttribute("data-ng_skip","1")}return this},input_mouseup_event:function(a){a.stop()},set_input:function(a){if(!ng.defined(this.p.input_focus_event)){this.p.input_focus_event=function(){if(this.p.open_onfocus){this.open()}}.bind(this)}if(!ng.defined(this.p.input_click_event)){this.p.input_click_event=function(){if(this.p.open_onclick){this.open()}}.bind(this)}if((ng.defined(this.p.input))&&(this.p.input.remove_events)){this.p.input.remove_events({focus:this.p.input_focus_event,click:this.p.input_click_event,mouseup:this.input_mouseup_event});this.p.input.setAttribute("data-ng_plugin","")}this.p.input=ng.get(a);if(!ng.defined(this.p.open_onfocus)){this.p.open_onfocus=true}if(!ng.defined(this.p.open_onclick)){this.p.open_onclick=true}this.p.input.setAttribute("data-ng_plugin",this.id);this.p.input.add_events({focus:this.p.input_focus_event,click:this.p.input_click_event,mouseup:this.input_mouseup_event});if(!ng.defined(this.p.first_time_input_set)){this.p.first_time_input_set=true}(function(){if(!ng.defined(this.p.input.paretNode)){return}if(this.p.first_time_input_set){this.p.first_time_input_set=false;return}if(this.p.input.paretNode.id!="input_button_container"+this.id){if(ng.defined(ng.get("input_button_container"+this.id))){var b=ng.get("input_button_container"+this.id);while(b.childNodes.length>0){b.append_element(b.childNodes[0],"before")}}else{var b=ng.create("span",{id:"input_button_container"+this.id})}this.p.input.append_element(b,"before");b.append_element(this.p.input)}}.delay(50,this));return this},get_input:function(a){return this.p.input},set_button:function(a){if(ng.defined(a)){if(ng.defined(this.p.button)){if((ng.defined(a.get_component()))&&(this.get_id()==a.get_component().get_id())){return this}if(this.p.button.remove_component){this.p.button.remove_component()}}a.set_component(this)}this.p.button=a;return this},get_button:function(){return this.p.button},set_placement:function(a){this.p.placement=a.toLowerCase();return this},get_placement:function(){return this.p.placement},set_offset:function(a){if(!ng.defined(a)){a={x:0,y:0}}this.p.offset=a;return this},get_offset:function(){if(!ng.defined(this.p.offset)){this.p.offset={x:0,y:0}}return this.p.offset},set_visible:function(a){if(a!=this.p.visible){if(!a){this.get_object().remove_class("ng-comp-visible");this.get_object().add_class("ng-comp-hidden");this.p.visible=a;this.close();if(ng.defined(this.p.button)){this.p.button.get_object().set_style("display","")}}else{this.get_object().remove_class("ng-comp-hidden");this.get_object().add_class("ng-comp-visible");this.open();this.p.visible=a;if(ng.defined(this.p.button)){this.p.button.get_object().set_style("display","none")}}}return this},get_visible:function(){return this.p.visible},set_open_onfocus:function(a){if(!ng.defined(a)){a=true}this.p.open_onfocus=a;return this},get_open_onfocus:function(){return this.p.open_onfocus},set_open_onclick:function(a){if(!ng.defined(a)){a=true}this.p.open_onclick=a;return this},get_open_onclick:function(){return this.p.open_onclick},get_input_html:function(){var b="";if(this.get_visible()){b=' style="display:none;"'}if(ng.UI){var a='<span class="ng-input-button-container" id="input_button_container'+this.id+'" dir="'+ng.Language.get_dir(this.get_language())+'"></span>';(function(){if((ng.defined(this.p.button))&&(ng.defined(this.p.input))){var f=this.p.button.get_object();var c=this.p.input;if(ng.defined(c)){var g=c.get_height();var e=f.get_height();if(e>g){var i=f.get_style("borderTopWidth").to_int();if(isNaN(i)){i=0}var d=f.get_style("borderBottomWidth").to_int();if(isNaN(d)){d=0}f.set_style("height",g-i-d)}else{if(e<g){g=g-e;f.set_styles({paddingTop:Math.floor(g/2),paddingBottom:Math.ceil(g/2)})}}}if(b!=""){this.p.button.get_object().set_style("display","none")}}}.delay(250,this))}else{var a="<table cellspacing='0' cellpadding='0' class='ng-input-button-table ng_input_button_table' id='input_button_container"+this.id+"' dir='"+ng.Language.get_dir(this.get_language())+"'>";a+="<tr><td id='input_holder_td"+this.id+"'></td><td id='button_holder_td"+this.id+"'"+b+"></td></tr>";a+="</table>"}return a},set_button_ui_class:function(a){if(ng.defined(this.p.button)){this.p.button.set_ui_class(a)}this.p.button_ui_class=a;return this},get_button_ui_class:function(a){if(ng.defined(this.p.button)){return this.p.button.get_ui_class()}return this.p.button_ui_class}});ng.all_component_arr={};ng.all_plugins_arr={};ng.close_all_component=function(b){var a=[];if((ng.defined(b))&&(ng.defined(ng.all_component_arr[b]))){var a=ng.all_component_arr[b].get_parents_components();a.push(b)}ng.obj_each(ng.all_component_arr,function(d,c){if(!ng.defined(d)){return}if(!a.has(c)){if(ng.defined(d.close())){d.close()}}})};ng.garbage_collect=(function(){ng.obj_each(ng.all_plugins_arr,function(b,a){if(!ng.defined(b)){return}var c;if((ng.defined(b.get_input))&&(ng.defined(b.get_input()))){c=b.get_input()}else{if(ng.defined(b.get_object())){c=b.get_object()}}if((ng.defined(c))&&(!document.body.contains(c))){b.q_garbage()}})}).repeat(30000);ng.doc.add_event("mouseup",function(a){if(a.left<15){return}if((ng.doc.get_width()+ng.doc.get_scroll_left()-a.left)<15){return}if((a.left-ng.doc.get_scroll_left())<10){return}ng.close_all_component()});ng.doc.add_event("keyup",function(a){if(a.key=="esc"){ng.close_all_component()}});ng.get(window).add_event("resize",function(){ng.obj_each(ng.all_component_arr,function(b,a){if(!b.get_visible()){b.reposition()}})});ng.ready(function(){(function(){ng.get(window).fire_event("resize")}.delay(250))});ng.Button=function(b){this.p=this.create_options(b,{render_top:true,render_right:true,render_bottom:true,render_left:true,color:ng_config.button_color,over_color:ng_config.button_over_color,down_color:ng_config.button_down_color,disable_color:ng_config.button_disable_color,checked_color:ng_config.button_checked_color,current_color:null,text_color:ng_config.button_text_color,light_border:ng_config.button_light_border,gloss:ng_config.button_gloss,arrow_style:"down",text_length:null,width:null,text:"",value:null,icon:null,component:null,hide_text:false,hide_icon:false,hide_component:false,disabled:false,checked:false,stop_default:false,layout:"ita",ui_class:"",count:""});this.create_events();this.p.enabled=!this.p.disabled;if(ng.type(this.p.color)=="string"){this.p.color=this.p.color.toLowerCase()}if(!ng.defined(this.p.over_color)){this.p.over_color=this.p.color}if(!ng.defined(this.p.down_color)){this.p.down_color=this.p.over_color}if(!ng.defined(this.p.checked_color)){this.p.checked_color=this.p.down_color}if(!ng.defined(this.p.disable_color)){if(ng.type(this.p.color)=="color"){this.p.disable_color=new ng.Color(this.p.color.get_hex())}else{if((this.p.color=="transparent")||(this.p.color=="none")){var a="#cccccc"}else{var a=this.p.color}this.p.disable_color=new ng.Color(a)}this.p.disable_color.desaturate()}this.make_id("button");this.set_object(this.p.object);if(ng.defined(this.p.component)){this.set_component(this.p.component)}if(ng.defined(this.p.object)){this.render()}};ng.Button.inherit(ng.PlugIn);ng.extend_proto(ng.Button,{has_type:"button",render:function(g){if(ng.defined(g)){this.set_object(g)}var g=this.get_object();var l=g.get("id");if(l!=""){l='id="'+l+'"'}var c=g.get("tag");if((g.disabled)||(g.getAttribute("disabled")=="disabled")){(function(){this.disable()}.defer(this))}if(((c=="input")||(c=="button"))&&(g.get("type")=="submit")&&(ng.defined(g.get("form")))){this.p.form=ng.get(g.get("form"));if((!ng.defined(this.p.stop_default))||(this.p.stop_default==false)){this.add_event("click",function(i){this.p.form.submit()})}if(!ng.defined(this.p.value)){this.p.value=this.p.text}}else{if(c=="a"){this.p.link=g.getAttribute("href");this.p.target=g.get("target");if((!ng.defined(this.p.stop_default))||(this.p.stop_default==false)){if((this.p.link!="")&&(this.p.link!="#")){this.add_event("click",function(i){if((this.p.target!="")&&(this.p.target!="_self")){window.open(this.p.link,this.p.target,"")}else{location.href=this.p.link}})}}}}this.p.xobjEvents=new ng.InnerHtmlEvents({click:function(o,i){this.click(i);i.stop()}.bind(this),focus:function(o,i){this.focus(i)}.bind(this),blur:function(o,i){this.blur(i)}.bind(this)});var a="";if((c=="input")||(c=="button")){if(this.get_text()==""){if(c=="button"){this.set_text(g.get_html())}else{this.set_text(g.value)}}if(this.get_value()==""){this.set_value(this.get_text())}if(g.get("type").toLowerCase()=="submit"){a='<div style="position:absolute; width:0px; height:0px; overflow:hidden;"><input '+l+' type="submit" name="'+g.name+'" value="'+this.get_value()+'" '+this.p.xobjEvents.get_html()+" /></div>"}}else{if(this.get_text()==""){this.set_text(g.get_html())}}var k="";if(a==""){if(c=="a"){if((!ng.defined(this.p.link))||(this.p.link=="")){this.p.link="#"}k="<a "+l+' href="'+this.p.link+'" '+this.p.xobjEvents.get_html()+">";a="</a>"}else{a='<div style="position:absolute; width:0px; height:0px; overflow:hidden;"><a '+l+' href="#" name="'+g.get("name")+'" value="'+this.get_value()+'" '+this.p.xobjEvents.get_html()+"></a></div>"}}var h=[];h.push('<span id="'+this.id+'" class="ng-button ');if(this.get_gloss()){h.push("ng-button-gloss ")}if((ng.defined(ng.UI))&&(this.p.ui_class!="")){h.push(this.p.ui_class+" ")}h.push(ng.Language.get_dir(this.get_language())+'" title="'+g.get("title")+'" data-ng_skip="1" onselectstart="return false">'+k);if(!ng.defined(ng.UI)){h.push("<div id='"+this.id+"_holder' class='ng-button-holder'><div id='"+this.id+"_bevel' class='ng-button-bevel'>");h.push('<table cellspacing="0" cellpadding="0" class="ng-button-table" id="'+this.id+'_maintable"><tr>');h.push('<td class="ng-button-icon-td" id="'+this.id+'_icon_td">');if(ng.defined(this.get_icon())){var j=this.get_icon();if(this.p.hide_icon){var m=' style="display:none;" '}else{var m=""}if(j.indexOf(".")==-1){var d=j.split(",");h.push('<span class="'+d[0].trim()+' ng-button-icon-span"'+m+' id="'+this.id+'_icon">');for(var f=1;f<d.length;f++){h.push('<span class="'+d[f].trim()+'">')}h.push("&nbsp;");for(var f=1;f<d.length;f++){h.push("</span>")}h.push("</span>")}else{h.push("<img src='"+j+"' border='0' id='"+this.id+"_icon' class='ng-button-icon-img'"+m+" />")}}h.push('</td><td class="ng-button-text-td" id="'+this.id+'_text_td">');if(this.p.hide_text){var m=' style="display:none;" '}else{var m=""}h.push("<span id='"+this.id+"_text'"+m+" class='ng-button-text-span'>"+this.get_text()+"</span>");h.push('</td><td id="'+this.id+'_component_td" class="ng-button-arrow-td">');if(ng.defined(this.get_component())){if(this.p.hide_component){var m=' style="display:none;" '}else{var m=""}h.push("<img id='"+this.id+"_component' class='ng-button-arrow-img'"+m+" />")}h.push("</td></tr></table>");h.push("</div></div>")}else{var m=' style="display:none;" ';if(this.p.count.toString()!=""){m=""}h.push('<b id="'+this.id+'_count"'+m+' class="ng-button-count">'+this.p.count+"</b>");m=' style="display:none;" ';var j="";if(ng.defined(this.get_icon())){j=this.get_icon()}if((!this.p.hide_icon)&&(j!="")){m=""}if(j.indexOf(".")==-1){var d=j.split(",");h.push('<span class="'+d[0].trim()+' ng-button-icon-span"'+m+' id="'+this.id+'_icon">');for(var f=1;f<d.length;f++){h.push('<span class="'+d[f].trim()+'">')}h.push("&nbsp;");for(var f=1;f<d.length;f++){h.push("</span>")}h.push("</span>")}else{h.push('<span id="'+this.id+'_icon" class="ng-button-icon-span"'+m+">");if(j==""){h.push("&nbsp;")}else{h.push('<img src="'+j+'" id="'+this.id+'_icon_img" border="0" class="ng-button-icon-img" />')}h.push("</span>")}m=' style=" display:none;" ';var e=this.get_text();if((!this.p.hide_text)&&(e!="")){m=""}h.push('<span id="'+this.id+'_text"'+m+' class="ng-button-text-span">'+e+"</span>");m=' style="display:none;" ';if((ng.defined(this.get_component()))&&(!this.p.hide_component)){m=""}h.push('<span id="'+this.id+'_component"'+m+' class="ng-button-arrow"></span>')}h.push(a);h.push("</span>");ng.hold_html(h.join(""));if(this.p.layout!="ita"){var b=this.p.layout;this.p.layout="ita";this.set_layout(b)}this.set_object(ng.get(this.id));g.replace(this.id);this.set_language(this.get_language());this.get_object().add_events({click:function(i){this.click(i)}.bind(this),mouseenter:function(i){this.mouseenter(i)}.bind(this),mouseleave:function(i){this.mouseleave(i)}.bind(this),mousedown:function(i){this.mousedown(i)}.bind(this),mouseup:function(i){this.mouseup(i);if(ng.defined(this.get_component())){i.stop()}}.bind(this)});var n=this.get_color();if(this.is_checked()){if(ng.defined(ng.UI)){ng.get(this.id).add_class("checked")}n=this.get_checked_color()}if(this.is_disabled()){if(ng.defined(ng.UI)){ng.get(this.id).add_class("disabled")}n=this.get_disable_color()}if(!ng.defined(ng.UI)){this.apply_colors(n);if(!this.p.render_top){this.hide_top()}if(!this.p.render_right){this.hide_right()}if(!this.p.render_bottom){this.hide_bottom()}if(!this.p.render_left){this.hide_left()}}if(ng.defined(this.p.width)){this.set_width(this.p.width)}return this},make:function(a,c){if(!ng.defined(a)){a=ng.get(document.body)}else{a=ng.get(a)}if(!ng.defined(c)){c="bottom"}var b=ng.create("a");a.append_element(b,c);this.p.stop_default=true;return this.render(b)},set_layout:function(n){n=n.toLowerCase();if(n==this.p.layout){return this}this.p.layout=n;if(n.indexOf("i")==-1){n="i"+n;this.hide_icon.defer(this)}else{this.show_icon.defer(this)}if(n.indexOf("t")==-1){n=n.replace("i","it");this.hide_text.defer(this)}else{this.show_text.defer(this)}if(n.indexOf("a")==-1){n=n+"a";this.hide_component.defer(this)}else{this.show_component.defer(this)}n=n.replace(/[^ita\|]/g,"");var m=n.split("|");var p="";if(m.length==3){p="ng-3-rows-button"}else{if(m.length==2){if(m[0].length>1){p="ng-2-rows-2-1-button"}else{p="ng-2-rows-1-2-button"}}}if(ng.defined(ng.UI)){var b=ng.get(this.id);b.remove_class("ng-3-rows-button").remove_class("ng-2-rows-2-1-button").remove_class("ng-2-rows-1-2-button");if(p!=""){ng.get(this.id).add_class(p)}n=n.replace(/\|/g,"");for(var h=n.length-1;h>=0;h--){var a=n.charAt(h);if(a=="i"){b.append_element(this.id+"_icon","top")}else{if(a=="t"){b.append_element(this.id+"_text","top")}else{if(a=="a"){b.append_element(this.id+"_component","top")}}}}return this}var l=1;for(var h=0;h<m.length;h++){l=Math.max(l,m[h].length)}var o=[];for(var h=0;h<m.length;h++){if(m[h].length){var d=o.length;o[d]=document.createElement("tr");for(var f=0;f<m[h].length;f++){var c="";if(m[h].charAt(f)=="i"){c=this.id+"_icon_td"}else{if(m[h].charAt(f)=="t"){c=this.id+"_text_td"}else{if(m[h].charAt(f)=="a"){c=this.id+"_component_td"}}}if(c!=""){c=ng.get(c);o[d].appendChild(c);if(f==0){c.colSpan=l-m[h].length+1}}}}}var g=ng.get(this.id+"_maintable");g.remove_class("ng-3-rows-button").remove_class("ng-2-rows-2-1-button").remove_class("ng-2-rows-1-2-button");if(p!=""){g.add_class(p)}var e=g.get_children("tbody")[0];e.innerHTML="";for(var h=0;h<o.length;h++){e.appendChild(o[h])}return this},get_layout:function(){return this.p.layout},apply_colors:function(n,l,g){if(ng.UI){return this}if(!ng.defined(ng.get(this.id+"_holder"))){return this}if(l){var j="_down"}else{var j=""}if((!ng.defined(g))&&(this.p.current_color==n.toString()+j)){return this}this.p.current_color=n.toString()+j;var m=false;var e=false;if(ng.type(n)!="color"){if(n=="transparent"){var n=new ng.Color("#ffffff");m=true}else{if(n=="none"){var n=new ng.Color("#ffffff");e=true}else{var n=new ng.Color(n)}}}var c=n.get_hex();if(this.p.light_border){var i="#ffffff";var f="#000000"}else{var i="#000000";var f="#ffffff"}var h=new ng.Color(n.get_hex()).mix(i,75);var d=new ng.Color(n.get_hex()).mix(f,50);var b=new ng.Color(n.get_hex()).mix(i,50);var a=n.get_luminance();if(ng.defined(ng.get(this.id+"_component"))){if(a>=50){ng.get(this.id+"_component").src=ng_config.assets_dir+"images/arrows/black_"+this.p.arrow_style+".png"}else{ng.get(this.id+"_component").src=ng_config.assets_dir+"images/arrows/white_"+this.p.arrow_style+".png"}}if(!ng.defined(this.get_text_color())){if(a>=50){var k="#000000"}else{var k="#ffffff"}}else{if(ng.type(this.get_text_color())=="color"){var k=this.get_text_color().get_hex()}else{var k=this.get_text_color()}}if(this.is_disabled()){k=new ng.Color(k).mix(c,50).get_hex();if(ng.defined(ng.get(this.id+"_component"))){ng.get(this.id+"_component").set_opacity(50)}}else{if(ng.defined(ng.get(this.id+"_component"))){ng.get(this.id+"_component").set_opacity(100)}}if(m){this.get_object().set_styles({background:"none","border-color":"#404040",color:k});ng.get(this.id+"_holder").set_style("border-color","#404040")}else{if(e){this.get_object().set_styles({background:"none","border-color":"transparent",color:k});ng.get(this.id+"_holder").set_style("border-color","transparent")}else{this.get_object().set_styles({"background-color":c,"border-color":h.get_hex(),color:k});ng.get(this.id+"_holder").set_style("border-color",h.get_hex())}}if(!ng.defined(l)){ng.get(this.id+"_bevel").set_styles({"border-color":d.get_hex(),"border-bottom-color":b.get_hex(),"border-right-color":b.get_hex()})}else{ng.get(this.id+"_bevel").set_styles({"border-color":d.get_hex(),"border-top-color":b.get_hex(),"border-left-color":b.get_hex()})}return this},set_down_background:function(a){if(ng.defined(ng.UI)){return this}if(a){this.get_object().add_class("ng-button-down");if(this.get_gloss()){ng.get(this.id+"_holder").add_class("ng-button-holder-gloss-down")}else{ng.get(this.id+"_holder").add_class("ng-button-holder-down")}}else{this.get_object().remove_class("ng-button-down");if(this.get_gloss()){ng.get(this.id+"_holder").remove_class("ng-button-holder-gloss-down")}else{ng.get(this.id+"_holder").remove_class("ng-button-holder-down")}}return this},over:function(){if(!this.p.enabled){return this}if(ng.defined(ng.UI)){ng.get(this.id).add_class("over")}else{this.set_down_background().apply_colors(this.get_over_color())}return this},out:function(){if(!this.p.enabled){return this}if(ng.defined(ng.UI)){ng.get(this.id).remove_class("over")}else{this.set_down_background().apply_colors(this.get_color())}return this},down:function(){if(!this.p.enabled){return this}if(ng.defined(ng.UI)){ng.get(this.id).add_class("down")}else{this.set_down_background(true).apply_colors(this.get_down_color(),true)}return this},up:function(){if(ng.defined(ng.UI)){ng.get(this.id).remove_class("down")}return this.over()},focus:function(a){if(!this.p.enabled){return this}this.over();return this.fire_event("focus",null,a)},blur:function(a){if(!this.p.enabled){return this}this.out();return this.fire_event("blur",null,a)},click:function(a){if(!this.p.enabled){return this}return this.fire_event("click",null,a)},mouseenter:function(a){if(!this.p.enabled){return this}if(!this.p.checked){this.over()}else{if(ng.defined(ng.UI)){this.over()}}return this.fire_event("mouseenter",null,a)},mouseleave:function(a){if(!this.p.enabled){return this}if(!this.p.checked){this.out()}else{if(ng.defined(ng.UI)){this.out()}}return this.fire_event("mouseleave",null,a)},mousedown:function(a){if(!this.p.enabled){return this}if(!this.p.checked){this.down()}else{if(ng.defined(ng.UI)){this.down()}}return this.fire_event("mousedown",null,a)},mouseup:function(a){if(!this.p.enabled){return this}if(!this.p.checked){this.up()}else{if(ng.defined(ng.UI)){this.up()}}return this.fire_event("mouseup",null,a)},is_disabled:function(){return !this.p.enabled},enable:function(){if(this.p.enabled){return this}this.p.enabled=true;if(ng.defined(ng.UI)){ng.get(this.id).remove_class("disabled")}else{this.set_down_background().apply_colors(this.get_color())}return this.fire_event("enable")},disable:function(){if(!this.p.enabled){return this}this.p.enabled=false;if(ng.defined(ng.UI)){ng.get(this.id).add_class("disabled")}else{this.set_down_background().apply_colors(this.get_disable_color())}return this.fire_event("disable")},is_checked:function(){return this.p.checked},check:function(){if(this.p.checked){return this}this.p.checked=true;if(ng.defined(ng.UI)){ng.get(this.id).add_class("checked")}else{this.set_down_background(true).apply_colors(this.get_checked_color())}return this.fire_event("check")},uncheck:function(){if(!this.p.checked){return this}this.p.checked=false;if(ng.defined(ng.UI)){ng.get(this.id).remove_class("checked")}this.out();return this.fire_event("uncheck")},set_value:function(a){this.p.value=a;if(ng.defined(ng.get("hidden_input"+this.id))){ng.get("hidden_input"+this.id).value=a}return this},get_value:function(){return this.p.value},set_text:function(a){var b=this.p.text;this.p.text=a;if(ng.defined(this.p.text_length)){a=a.shorten(this.p.text_length)}if(ng.defined(ng.get(this.id+"_text"))){ng.get(this.id+"_text").set_html(a);ng.get(this.id).title=this.p.text}if((ng.defined(ng.UI))&&ng.defined(ng.get(this.id+"_text"))&&(b=="")&&(!this.p.hide_text)){ng.get(this.id+"_text").set_style("display","")}},get_text:function(){return this.p.text},set_text_style:function(b,a){ng.get(this.id+"_text").set_style(b,a);return this},set_text_styles:function(a){ng.get(this.id+"_text").set_styles(a);return this},get_text_element:function(){return ng.get(this.id+"_text")},is_text_hidden:function(){return(ng.get(this.id+"_text").get_style("display")=="none")},set_text_length:function(a){if(a=="auto"){a=null}this.p.text_length=a;return this.set_text(this.p.text)},get_text_length:function(){return this.p.text_length},show_text:function(){if(ng.defined(ng.get(this.id+"_text"))){ng.get(this.id+"_text").set_style("display","")}return this},hide_text:function(){if(ng.defined(ng.get(this.id+"_text"))){ng.get(this.id+"_text").set_style("display","none")}return this},set_width:function(a){if(!ng.defined(a)){a="auto"}this.p.width=a;this.p.object.set_style("width",a);return this},get_width:function(){if(!ng.defined(this.p.width)){this.p.width=this.p.object.get_style("width").to_int()}return this.p.width},set_icon:function(e){if(ng.defined(ng.UI)){if(ng.defined(ng.get(this.id+"_icon_img"))){ng.get(this.id+"_icon_img").remove_element()}var d=ng.create("span",{id:this.id+"_icon",className:"ng-button-icon-span"});if(e.indexOf(".")==-1){var a=e.split(",");d.className+=" "+a[0].trim();var c=[];for(var b=1;b<a.length;b++){c.push('<span class="'+a[b].trim()+'">')}c.push("&nbsp;");for(var b=1;b<a.length;b++){c.push("</span>")}d.set_html(c)}else{d.append_element(ng.create("img",{id:this.id+"_icon_img",className:"ng-button-icon-img",src:e}))}}else{if(e.indexOf(".")==-1){var d=ng.create("span",{id:this.id+"_icon",className:"ng-button-icon-span"});var a=e.split(",");d.className+=" "+a[0].trim();var c=[];for(var b=1;b<a.length;b++){c.push('<span class="'+a[b].trim()+'">')}c.push("&nbsp;");for(var b=1;b<a.length;b++){c.push("</span>")}d.set_html(c)}else{var d=ng.create("img",{id:this.id+"_icon",className:"ng-button-icon-img",src:e})}}if(this.p.hide_icon){d.set_style("display","none")}if(ng.defined(ng.get(this.id+"_icon"))){ng.get(this.id+"_icon").replace(d)}else{ng.get(this.id+"_icon_td").append_element(d,"top")}this.p.icon=e;return this},get_icon:function(){return this.p.icon},get_icon_element:function(){if(ng.defined(ng.get(this.id+"_icon"))){return ng.get(this.id+"_icon")}return null},is_icon_hidden:function(){if(!ng.defined(this.id+"_icon")){return false}return(ng.get(this.id+"_icon").get_style("display")=="none")},hide_icon:function(){if(ng.defined(ng.get(this.id+"_icon"))){ng.get(this.id+"_icon").set_style("display","none")}return this},show_icon:function(){if(ng.defined(ng.get(this.id+"_icon"))){ng.get(this.id+"_icon").set_style("display","")}return this},set_count:function(a){if(!ng.defined(ng.get(this.id+"_count"))){return this}if(!ng.defined(a)){a=""}this.p.count=a;ng.get(this.id+"_count").set_html(a);if(a==""){ng.get(this.id+"_count").set_style("display","none")}else{ng.get(this.id+"_count").set_style("display","")}return this},get_count:function(){return this.p.count},set_component:function(b){if(ng.defined(ng.UI)){if(!this.p.hide_component){ng.get(this.id+"_component").set_style("display","")}if(b.get_button_ui_class()!=""){ng.get(this.id).add_class(b.get_button_ui_class())}}else{if((ng.defined(ng.get(this.id+"_component_td")))&&(!ng.defined(ng.get(this.id+"_component")))){var a=ng.create("img",{id:this.id+"_component",className:"ng-button-arrow-img"});if(this.p.hide_component){a.set_style("display","none")}ng.get(this.id+"_component_td").append_element(a)}}if(!ng.defined(this.comp_click_event)){this.comp_click_event=function(c){if(ng.defined(this.p.component.get_input())){this.p.component.toggle()}else{this.p.component.toggle(this)}c.stop_default()};this.comp_open_event=function(){this.check()}.bind(this);this.comp_close_event=function(){this.uncheck()}.bind(this)}else{this.remove_event("click",this.comp_click_event);if(ng.defined(this.p.component)){this.p.component.remove_events({open:this.comp_open_event,close:this.comp_close_event})}}this.add_event("click",this.comp_click_event);this.p.component=b;this.p.component.add_events({open:this.comp_open_event,close:this.comp_close_event});if(ng.defined(ng.get(this.id))){this.out()}if(ng.defined(ng.UI)){ng.get(this.id).remove_class("over");return this}else{return this.apply_colors(this.get_color(),null,true)}},remove_component:function(){if(ng.defined(ng.UI)){if(ng.defined(ng.get(this.id+"_component"))){ng.get(this.id+"_component").set_style("display","none")}}else{if(ng.defined(ng.get(this.id+"_component"))){ng.get(this.id+"_component").remove()}}if(ng.defined(this.comp_click_event)){this.remove_event("click",this.comp_click_event);if(ng.defined(this.p.component)){this.p.component.remove_events({open:this.comp_open_event,close:this.comp_close_event})}}if(ng.defined(this.p.component)){this.p.component.set_button(null)}return this},get_component:function(){return this.p.component},get_component_element:function(){if(ng.defined(ng.get(this.id+"_component"))){return ng.get(this.id+"_component")}return null},is_component_hidden:function(){if(!ng.defined(this.id+"_component")){return false}return(ng.get(this.id+"_component").get_style("display")=="none")},hide_component:function(){if(ng.defined(ng.get(this.id+"_component"))){ng.get(this.id+"_component").set_style("display","none")}return this},show_component:function(){if(ng.defined(ng.get(this.id+"_component"))){ng.get(this.id+"_component").set_style("display","")}return this},set_gloss:function(a){this.p.gloss=a;if(a){this.get_object().add_class("ng-button-gloss")}else{this.get_object().remove_class("ng-button-gloss")}return this},get_gloss:function(){return this.p.gloss},set_color:function(a){this.p.color=a;return this.out()},get_color:function(){return this.p.color},set_over_color:function(a){this.p.over_clr=a;return this.out()},get_over_color:function(){return this.p.over_color},set_down_color:function(a){this.p.down_color=a;return this.out()},get_down_color:function(){return this.p.down_color},set_disable_color:function(a){this.p.disable_color=a;return this.out()},get_disable_color:function(){return this.p.disable_color},set_checked_color:function(a){this.p.checked_color=a;return this.out()},get_checked_color:function(){return this.p.checked_color},set_text_color:function(a){this.p.text_color=a;return this.out()},get_text_color:function(){return this.p.text_color},set_arrow_style:function(a){this.p.arrow_style=a;return this.out()},get_arrow_style:function(){return this.p.arrow_style},hide_borders:function(){return this.hide_top().hide_left().hide_right().hide_bottom()},show_borders:function(){return this.show_top().show_left().show_right().show_bottom()},hide_top:function(){this.get_object().set_style("border-top-width","0px");return this},show_top:function(){this.get_object().set_style("border-top-width","1px");return this},hide_bottom:function(){this.get_object().set_style("border-bottom-width","0px");return this},show_bottom:function(){this.get_object().set_style("border-bottom-width","1px");return this},hide_left:function(){ng.get(this.id+"_holder").set_style("border-left-width","0px");return this},show_left:function(){ng.get(this.id+"_holder").set_style("border-left-width","1px");return this},hide_right:function(){ng.get(this.id+"_holder").set_style("border-right-width","0px");return this},show_right:function(){ng.get(this.id+"_holder").set_style("border-right-width","1px");return this},set_ui_class:function(a){if(this.p.ui_class!=""){this.get_object().remove_class(this.p.ui_class)}this.p.ui_class=a;this.get_object().add_class(a)},get_ui_class:function(){return this.p.ui_class},set_link:function(a){this.p.link=a;return this},get_link:function(){return this.p.link}});(function(){if(!ng_config.use_ui){return}if((ng.browser.ie)&&(ng.browser.get_ie_version()<9)){return}ng.Assets.load_style(ng_config.assets_dir+"css/"+ng_config.css_skin_prefix+"ui.css");if(ng_config.load_icons){ng.Assets.load_style(ng_config.assets_dir+"css/"+ng_config.css_skin_prefix+"icons.css")}ng.UI={ini_funcs:{},add_to_ini:function(b,c){ng.UI.ini_funcs[b]=c},common_ini:function(c,b){var c=ng.get(c);if(c.getAttribute("data-ng_skip")=="1"){return}c.setAttribute("data-ng_skip","1");new b(c)},ini:function(){ng.obj_each(ng.UI.ini_funcs,function(c,b){ng.UI.create(b,c,document.body)})},create:function(b,f,d){var e=ng.get(d).get_children_by_class_name(b,"");for(var c=0;c<e.length;c++){if(e[c].getAttribute("data-ng_skip")!="1"){f(e[c])}}},match_buttons_height:function(c){var b=0;ng.get(c).get_children_by_class_name("ng-button","*",function(d){b=Math.max(b,d.get_style("height").to_int())});if(b==0){return}ng.get(c).get_children_by_class_name("ng-button","*",function(d){d.set_style("height",b)})}};var a=function(e){if(e.getAttribute("data-ng_skip")=="1"){return}if(e.get("tag")=="label"){var d=e.getElementsByTagName("input");if(d.length){d=ng.get(d[0]);e.append_element(d,"after");d.set_style("display","none");var b=d.type.toLowerCase();var c=ng.create("button",{className:d.className+" "+b,html:e.innerHTML,type:"button"});if(ng.defined(e.dataset)){ng.obj_each(e.dataset,function(h,g){c.dataset[g]=e.dataset[g]})}c.setAttribute("data-stop_default","1");if(d.checked){c.setAttribute("data-checked","1")}if(d.disabled){c.setAttribute("data-disabled","1")}e.append_element(c,"before");e.remove_element();var e=f(c);e.p.input_field=d;if(b=="radio"){if(!ng.defined(ng.radio_buttons)){ng.radio_buttons={}}if(d.checked){ng.radio_buttons[d.name]=e}e.add_event("click",function(){if(ng.defined(ng.radio_buttons[this.p.input_field.name])){ng.radio_buttons[this.p.input_field.name].uncheck()}this.p.input_field.checked=true;ng.radio_buttons[this.p.input_field.name]=this;this.check()})}else{if(d.type.toLowerCase()=="checkbox"){e.add_event("click",function(){this.p.input_field.checked=!this.p.input_field.checked;if(this.p.input_field.checked){this.check()}else{this.uncheck()}})}}}}else{f(e)}function f(l){var m=l.get("data-split");if((ng.defined(m))&&(m!="")){var n=ng.create("span",{className:"ng-split-button"});l.append_element(n,"before");n.append_element(l);var j=ng.create(l.get("tag"),{className:l.className});j.setAttribute("data-options",m);n.append_element(j);f(j)}var g=l.get("data-options");var k;if((ng.defined(g))&&(g!="")){k=new ng.Component({responsive_left:0});var h=k.get_content_div();g=ng.get(g);h.remove_class("ng-comp-main-div").append_element(g);g.add_class("ng-floating").remove_class("ng-sub-buttons");g.add_event("mouseup",function(p){k.close()});l.setAttribute("data-stop_default",1)}var o=l.className.replace("ng-button","").trim();if(o!=""){l.setAttribute("data-ui_class",o)}var i=new ng.Button(l);if(ng.defined(k)){i.set_component(k).show_component()}return i}};ng.UI.add_to_ini("ng-button",a);ng.UI.add_to_ini("ng-buttons-horizontal",ng.UI.match_buttons_height);ng.ready(function(){ng.UI.ini.defer()})})();ng.ProgressBar=function(a){this.p=this.create_options(a,{css_prefix:"ng_progress_",style:"bar",bg_color:null,text_color:null,language:ng_config.language,value:null,hide:false,overlap:null,overlap_style:null,complete_text:null,complete_class:"",indeterminate_text:null,hide_text:false});this.create_events();this.make_id("progress");if((ng.browser.ie)&&(ng.browser.get_ie_version()<9)){this.p.style="bar"}if(!ng.defined(this.p.complete_text)){this.set_complete_text(ng.Language.t("complete",this.p.language))}if(!ng.defined(this.p.indeterminate_text)){this.set_indeterminate_text(ng.Language.t("loading",this.p.language))}this.p.indeterminate_timer=0;this.p.indeterminate_left=0;if(ng.defined(this.p.object)){this.render(this.p.object)}};(function(){if(!ng_config.use_ui){return}if((ng.browser.ie)&&(ng.browser.get_ie_version()<9)){return}ng.Assets.load_style(ng_config.assets_dir+"css/"+ng_config.css_skin_prefix+"ui.css");if(ng_config.load_icons){ng.Assets.load_style(ng_config.assets_dir+"css/"+ng_config.css_skin_prefix+"icons.css")}ng.UI={ini_funcs:{},add_to_ini:function(b,c){ng.UI.ini_funcs[b]=c},common_ini:function(c,b){var c=ng.get(c);if(c.getAttribute("data-ng_skip")=="1"){return}c.setAttribute("data-ng_skip","1");new b(c)},ini:function(){ng.obj_each(ng.UI.ini_funcs,function(c,b){ng.UI.create(b,c,document.body)})},create:function(b,f,d){var e=ng.get(d).get_children_by_class_name(b,"");for(var c=0;c<e.length;c++){if(e[c].getAttribute("data-ng_skip")!="1"){f(e[c])}}},match_buttons_height:function(c){var b=0;ng.get(c).get_children_by_class_name("ng-button","*",function(d){b=Math.max(b,d.get_style("height").to_int())});if(b==0){return}ng.get(c).get_children_by_class_name("ng-button","*",function(d){d.set_style("height",b)})}};var a=function(e){if(e.getAttribute("data-ng_skip")=="1"){return}if(e.get("tag")=="label"){var d=e.getElementsByTagName("input");if(d.length){d=ng.get(d[0]);e.append_element(d,"after");d.set_style("display","none");var b=d.type.toLowerCase();var c=ng.create("button",{className:d.className+" "+b,html:e.innerHTML,type:"button"});if(ng.defined(e.dataset)){ng.obj_each(e.dataset,function(h,g){c.dataset[g]=e.dataset[g]})}c.setAttribute("data-stop_default","1");if(d.checked){c.setAttribute("data-checked","1")}if(d.disabled){c.setAttribute("data-disabled","1")}e.append_element(c,"before");e.remove_element();var e=f(c);e.p.input_field=d;if(b=="radio"){if(!ng.defined(ng.radio_buttons)){ng.radio_buttons={}}if(d.checked){ng.radio_buttons[d.name]=e}e.add_event("click",function(){if(ng.defined(ng.radio_buttons[this.p.input_field.name])){ng.radio_buttons[this.p.input_field.name].uncheck()}this.p.input_field.checked=true;ng.radio_buttons[this.p.input_field.name]=this;this.check()})}else{if(d.type.toLowerCase()=="checkbox"){e.add_event("click",function(){this.p.input_field.checked=!this.p.input_field.checked;if(this.p.input_field.checked){this.check()}else{this.uncheck()}})}}}}else{f(e)}function f(l){var m=l.get("data-split");if((ng.defined(m))&&(m!="")){var n=ng.create("span",{className:"ng-split-button"});l.append_element(n,"before");n.append_element(l);var j=ng.create(l.get("tag"),{className:l.className});j.setAttribute("data-options",m);n.append_element(j);f(j)}var g=l.get("data-options");var k;if((ng.defined(g))&&(g!="")){k=new ng.Component({responsive_left:0});var h=k.get_content_div();g=ng.get(g);h.remove_class("ng-comp-main-div").append_element(g);g.add_class("ng-floating").remove_class("ng-sub-buttons");g.add_event("mouseup",function(p){k.close()});l.setAttribute("data-stop_default",1)}var o=l.className.replace("ng-button","").trim();if(o!=""){l.setAttribute("data-ui_class",o)}var i=new ng.Button(l);if(ng.defined(k)){i.set_component(k).show_component()}return i}};ng.UI.add_to_ini("ng-button",a);ng.UI.add_to_ini("ng-buttons-horizontal",ng.UI.match_buttons_height);ng.ready(function(){ng.UI.ini.defer()})})();